//////////////////////////////////////////////////////////////////////
//
//  _CHKBASE.CH
//
//  Copyright:
//       Alaska Software, (c) 1996-2023. All rights reserved.         
//  
//  Contents:
//       Translate directives for program code calling CA-Tools III
//       functions. This file checks your program code for functions
//       which are not supported by XbTools-III. This file is to be
//       used with XBTBASE.LIB
//   
//////////////////////////////////////////////////////////////////////


#ifndef _CHKBASE_CH

   #translate BiosDate([<x,...>])      =>  #error Function BiosDate is not supported
   #translate BootCold([<x,...>])      =>  #error Function BootCold is not supported
   #translate BootWarm([<x,...>])      =>  #error Function BootWarm is not supported
   #translate Com_DosCon([<x,...>])    =>  #error Function Com_DosCon is not supported
   #translate Com_Event([<x,...>])     =>  #error Function Com_Event is not supported
   #translate Com_GetIO([<x,...>])     =>  #error Function Com_GetIO is not supported
   #translate Com_GetIRQ([<x,...>])    =>  #error Function Com_GetIRQ is not supported
   #translate Com_Key([<x,...>])       =>  #error Function Com_Key is not supported
   #translate Com_Remote([<x,...>])    =>  #error Function Com_Remote is not supported
   #translate Com_SKey([<x,...>])      =>  #error Function Com_SKey is not supported
   #translate Com_SetIO([<x,...>])     =>  #error Function Com_SetIO is not supported
   #translate Com_SetIRQ([<x,...>])    =>  #error Function Com_SetIRQ is not supported
   #translate CpuType([<x,...>])       =>  #error Function CpuType is not supported
   #translate CsetClip([<x,...>])      =>  #error Function CsetClip is not supported
   #translate CsetFunc([<x,...>])      =>  #error Function CsetFunc is not supported
   #translate CsetSnow([<x,...>])      =>  #error Function CsetSnow is not supported
   #translate DSetKBios([<x,...>])     =>  #error Function DSetKBios is not supported
   #translate DSetNoline([<x,...>])    =>  #error Function DSetNoline is not supported
   #translate DSetQFile([<x,...>])     =>  #error Function DSetQFile is not supported
   #translate DSetWindow([<x,...>])    =>  #error Function DSetWindow is not supported
   #translate DiskFormat([<x,...>])    =>  #error Function DiskFormat is not supported
   #translate DiskSpeed([<x,...>])     =>  #error Function DiskSpeed is not supported
   #translate DiskStat([<x,...>])      =>  #error Function DiskStat is not supported
   #translate EgaPalette([<x,...>])    =>  #error Function EgaPalette is not supported
   #translate ErrorAct([<x,...>])      =>  #error Function ErrorAct is not supported
   #translate ErrorBase([<x,...>])     =>  #error Function ErrorBase is not supported
   #translate ErrorCode([<x,...>])     =>  #error Function ErrorCode is not supported
   #translate ErrorOrg([<x,...>])      =>  #error Function ErrorOrg is not supported
   #translate FirstCol([<x,...>])      =>  #error Function FirstCol is not supported
   #translate FirstRow([<x,...>])      =>  #error Function FirstRow is not supported
   #translate FontSelect([<x,...>])    =>  #error Function FontSelect is not supported
   #translate GetPbios([<x,...>])      =>  #error Function GetPbios is not supported
   #translate GetVgaPal([<x,...>])     =>  #error Function GetVgaPal is not supported
   #translate InByte([<x,...>])        =>  #error Function InByte is not supported
   #translate InWord([<x,...>])        =>  #error Function InWord is not supported
   #translate KbdDisable([<x,...>])    =>  #error Function KbdDisable is not supported
   #translate KbdEmulate([<x,...>])    =>  #error Function KbdEmulate is not supported
   #translate KbdSpeed([<x,...>])      =>  #error Function KbdSpeed is not supported
   #translate KeySec([<x,...>])        =>  #error Function KeySec is not supported
   #translate KeyTime([<x,...>])       =>  #error Function KeyTime is not supported
   #translate KsetCaps([<x,...>])      =>  #error Function KsetCaps is not supported
   #translate KsetIns([<x,...>])       =>  #error Function KsetIns is not supported
   #translate KsetNum([<x,...>])       =>  #error Function KsetNum is not supported
   #translate KsetScroll([<x,...>])    =>  #error Function KsetScroll is not supported
   #translate LastkFunc([<x,...>])     =>  #error Function LastkFunc is not supported
   #translate LastkLine([<x,...>])     =>  #error Function LastkLine is not supported
   #translate LastkProc([<x,...>])     =>  #error Function LastkProc is not supported
   #translate MoniSwitch([<x,...>])    =>  #error Function MoniSwitch is not supported
   #translate NumBuffers([<x,...>])    =>  #error Function NumBuffers is not supported
   #translate OutByte([<x,...>])       =>  #error Function OutByte is not supported
   #translate OutWord([<x,...>])       =>  #error Function OutWord is not supported
   #translate PeekByte([<x,...>])      =>  #error Function PeekByte is not supported
   #translate PeekStr([<x,...>])       =>  #error Function PeekStr is not supported
   #translate PeekWord([<x,...>])      =>  #error Function PeekWord is not supported
   #translate PokeByte([<x,...>])      =>  #error Function PokeByte is not supported
   #translate PokeWord([<x,...>])      =>  #error Function PokeWord is not supported
   #translate PrintScrX([<x,...>])     =>  #error Function PrintScrX is not supported
   #translate SetLastkey([<x,...>])    =>  #error Function SetLastkey is not supported
   #translate SetMaxCol([<x,...>])     =>  #error Function SetMaxCol is not supported
   #translate SetMaxRow([<x,...>])     =>  #error Function SetMaxRow is not supported
   #translate SetPbios([<x,...>])      =>  #error Function SetPbios is not supported
   #translate SetQname([<x,...>])      =>  #error Function SetQname is not supported
   #translate ShowKey([<x,...>])       =>  #error Function ShowKey is not supported
   #translate Speed([<x,...>])         =>  #error Function Speed is not supported
   #translate SsetBreak([<x,...>])     =>  #error Function SsetBreak is not supported
   #translate StackFree([<x,...>])     =>  #error Function StackFree is not supported
   #translate ToF([<x,...>])           =>  #error Function ToF is not supported
   #translate TrapAnyKey([<x,...>])    =>  #error Function TrapAnyKey is not supported
   #translate TrapInput([<x,...>])     =>  #error Function TrapInput is not supported
   #translate TrapShift([<x,...>])     =>  #error Function TrapShift is not supported
   #translate VgaPalette([<x,...>])    =>  #error Function VgaPalette is not supported

#define _CHKBASE_CH
#endif
* EOF *
