//////////////////////////////////////////////////////////////////////
//
//  ACHOICE.CH
//
//  Copyright:
//      Alaska Software, (c) 1998-2023. All rights reserved.         
//  
//  Contents:
//      #define constants for the AChoice() user function or
//      the user defined code block
//   
//////////////////////////////////////////////////////////////////////


// Achoice.ch is not included
#ifndef  _ACHOICE_CH      

*******************************************************************************
* Defines for Achoice() mode when calling the user function or code block
*******************************************************************************

// Wait for next event
#define  AC_IDLE       0  
// First element of the array was reached already
#define  AC_HITTOP     1  
// Last element of the array was reached already
#define  AC_HITBOTTOM  2  
// Last event was not processed by Achoice()
#define  AC_EXCEPT     3  
// Array has no elements or there are no selectable elements
#define  AC_NOITEM     4  

*******************************************************************************
* Return value of user function or code block
*******************************************************************************

// Terminate AChoice(), RETURN --> 0
#define  AC_ABORT      0  
// Terminate AChoice(), RETURN --> Position of 
//                    the selected array element
#define  AC_SELECT     1  
// Continue AChoice()
#define  AC_CONT       2  
// Position highlight to the element that corresponds to the last input letter
#define  AC_GOTO       3  
// Redisplay all array elements in the AChoice() window
#define  AC_REDRAW     4  

// Achoice.ch is included
#define  _ACHOICE_CH      

#endif  // #ifndef _ACHOICE_CH
