//////////////////////////////////////////////////////////////////////
//
//  APPBROW.CH
//
//  Copyright:
//      Alaska Software, (c) 1998-2023. All rights reserved.         
//  
//  Contents:
//      Command APPBROWSE and constants for the Appbrowse() system
//   
//////////////////////////////////////////////////////////////////////


#ifndef _APPBROWSE_CH


*******************************************************************************
* Final translation of the APPBROWSE command
*******************************************************************************
#command _APPBROWSE INTO <oBrowse>  ;
              [ PARENT <parent> ] ;
              [ FIELDS <fields,...> ] ;
               [ COLOR <fgC1> [, <bgC1> ] ] ;
              [ HILITE <fgC2> [, <bgC2> ] ] ;
                [ FONT <(font)> ] ;
            [ POSITION <pos1> [, <pos2>] ] ; 
                [ SIZE <siz1> [, <siz2>] [<per:PERCENT>] ] ; 
               [ TITLE <title> ] ;
               [ STYLE <style> ] ;
               [ ALIAS <(alias)> ] ;
                 [ FOR <(for)> ] ;
=> ;
  <oBrowse>:= AppBrowseNew(<parent>,,;
                        __appPos(<pos1>[,<pos2>]),;  
                        __appSiz([<per>,]<siz1>[,<siz2>]),; 
                        __PresParam([{XBP_PP_CAPTION,<(title)>}];
                                    [,{XBP_PP_COMPOUNDNAME,<(font)>}];
                                    [,{XBP_PP_FGCLR,<fgC1>}];
                                    [,{XBP_PP_BGCLR,<bgC1>}];
                                    [,{XBP_PP_HILITE_FGCLR,<fgC2>}];
                                    [,{XBP_PP_HILITE_BGCLR,<bgC2>}]),;
                        <style>,;
                        <(alias)>,;
                        {<{for}>,<(for)>});
                       [:fieldList( {<(fields)>} )]


#xtrans  APPBROWSE [<clauses,...>] STYLE PLAIN [<*more*>] ;
     =>  APPBROWSE [<clauses>] STYLE APPSTYLE_PLAIN [<more>]

#xtrans  APPBROWSE [<clauses,...>] STYLE 3D [<*more*>] ;
     =>  APPBROWSE [<clauses>] STYLE APPSTYLE_3D [<more>]

#xtrans  APPBROWSE [<clauses,...>] STYLE FANCY [<*more*>] ;
     =>  APPBROWSE [<clauses>] STYLE APPSTYLE_FANCY [<more>]

#xtrans  APPBROWSE [<clauses,...>] STYLE SYSTEM [<*more*>] ;
     =>  APPBROWSE [<clauses>] STYLE APPSTYLE_SYSTEMDEFAULT [<more>]


*******************************************************************************
* Make sure that the APPBROWSE command assigns an AppBrowse object to a variable
*******************************************************************************
#command  APPBROWSE [<clauses,...>] => ;
          _APPBROWSE INTO appObject [<clauses>]

#command  APPBROWSE INTO <oApp> [<clauses,...>] => ;
          _APPBROWSE INTO <oApp> [<clauses>]


#define _APPBROWSE_CH

#include "App.ch"

#endif
