//////////////////////////////////////////////////////////////////////
//
//  APPEDIT.CH
//
//  Copyright:
//      Alaska Software, (c) 1998-2023. All rights reserved.         
//  
//  Contents:
//      Command APPEDIT and constants for the AppEdit() system
//   
//////////////////////////////////////////////////////////////////////


#ifndef _APPEDIT_CH

*******************************************************************************
* Final translation of the APPEDIT command
*******************************************************************************
#command _APPEDIT INTO <oEdit>  ;
              [ PARENT <parent> ] ;
              [ FIELDS <fields,...> ] ;
               [ COLOR <fgC> [, <bgC> ] ] ;
                [ FONT <(font)> ] ;
            [ POSITION <pos1> [, <pos2>] ] ; 
                [ SIZE <siz1> [, <siz2>] [<per:PERCENT>] ] ; 
               [ TITLE <title> ] ;
             [ CAPTION [ FONT <(cFont)>] ;
                       [ COLOR <cFgC> [, <cBgC>] ] ;
                       [ ALIGN <cAlign:LEFT,CENTER,RIGHT> ] ] ;
             [ HEADING <(head)> [ FONT <(hFont)>] ;
                               [ COLOR <hFgC> [, <hBgC>] ] ;
                               [ ALIGN <hAlign:LEFT,CENTER,RIGHT> ] ] ;
               [ STYLE <style> ] ;
            [ NOACTION <suppress> ] ;
               [ ALIAS <(alias)> ] ;
                 [SEEK <seek> ] ;
                 [ FOR <(for)> ] ;
               [ WHILE <(while)> ] ;
             [ TRIGGER <delete> [ON] DELETE ] ;
             [ TRIGGER <Insert> [ON] INSERT ] ;
             [ TRIGGER <update> [ON] UPDATE ] ;
              [ BITMAP <bitmap> [ <fit:FIT> ] ] ;
=> ;
  <oEdit>:= AppEditNew(<parent>,,;
                        __appPos(<pos1>[,<pos2>]),;  
                        __appSiz([<per>,]<siz1>[,<siz2>]),; 
                        __PresParam([{XBP_PP_CAPTION,<(title)>}];
                                    [,{XBP_PP_COMPOUNDNAME,<(font)>}];
                                    [,{XBP_PP_FGCLR,<fgC>}];
                                    [,{XBP_PP_BGCLR,<bgC>}]),;
                        <style>,;
                        <suppress>,;
                        __PresParam([{XBP_PP_COMPOUNDNAME,<(cFont)>}];
                                    [,{XBP_PP_FGCLR,<cFgC>}];
                                    [,{XBP_PP_BGCLR,<cBgC>}];
                                    [,{__ALIGN,<cAlign>}]),;
                        __PresParam([{XBP_PP_CAPTION,<(head)>}];
                                    [,{XBP_PP_COMPOUNDNAME,<(hFont)>}];
                                    [,{XBP_PP_FGCLR,<hFgC>}];
                                    [,{XBP_PP_BGCLR,<hBgC>}];
                                    [,{__ALIGN,<hAlign>}]),;
                        {<bitmap>,<.fit.>},;
                        <(alias)>,;
                        <{seek}>,;
                        {<{for}>,<(for)>},;
                        <{while}>,;
                        {<delete>,<Insert>,<update>});
                       [:fieldList( {<(fields)>} )]


#xtrans  APPEDIT [<clauses,...>] STYLE PLAIN [<*more*>] ;
     =>  APPEDIT [<clauses>] STYLE APPSTYLE_PLAIN [<more>]

#xtrans  APPEDIT [<clauses,...>] STYLE 3D [<*more*>] ;
     =>  APPEDIT [<clauses>] STYLE APPSTYLE_3D [<more>]

#xtrans  APPEDIT [<clauses,...>] STYLE FANCY [<*more*>] ;
     =>  APPEDIT [<clauses>] STYLE APPSTYLE_FANCY [<more>]

#xtrans  APPEDIT [<clauses,...>] STYLE SYSTEM [<*more*>] ;
     =>  APPEDIT [<clauses>] STYLE APPSTYLE_SYSTEMDEFAULT [<more>]


*******************************************************************************
* Make sure that the APPEDIT command assigns an AppEdit object to a variable
*******************************************************************************
#command  APPEDIT [<clauses,...>] => ;
          _APPEDIT INTO appObject [<clauses>]

#command  APPEDIT INTO <oApp> [<clauses,...>] => ;
          _APPEDIT INTO <oApp> [<clauses>]


#define _APPEDIT_CH

#include "App.ch"
#include "Natmsg.ch"

#endif
