//////////////////////////////////////////////////////////////////////
//
//  CLASS.CH
//
//  Copyright:
//      Alaska Software, (c) 1998-2023. All rights reserved.         
//  
//  Contents:
//      constant for the dynamic creation of classes
//   
//////////////////////////////////////////////////////////////////////


#ifndef  _CLASS_CH

// constants for classCreate()

// default
#define CLASS_HIDDEN         0x0001   
#define CLASS_PROTECTED      0x0002
#define CLASS_EXPORTED       0x0003

#define VAR_ASSIGN_HIDDEN    0x0010  
#define VAR_ASSIGN_PROTECTED 0x0020
// default is CLASS_... value
#define VAR_ASSIGN_EXPORTED  0x0030   

// default
#define VAR_INSTANCE         0x0100   
#define VAR_CLASS            0x0300
#define VAR_CLASS_SHARED     0x0B00

// default
#define METHOD_INSTANCE      0x0010   
#define METHOD_CLASS         0x0020

#define METHOD_ACCESS        0x0400
#define METHOD_ASSIGN        0x0800

// defines for :classDescribe(<nMode>)
#define CLASS_DESCR_ALL          0
#define CLASS_DESCR_CLASSNAME    1
#define CLASS_DESCR_SUPERCLASSES 2
#define CLASS_DESCR_MEMBERS      3
#define CLASS_DESCR_METHODS      4
#define CLASS_DESCR_SUPERDETAILS 5

// index into member array returned by :classDescribe()
#define CLASS_MEMBER_NAME         1
#define CLASS_MEMBER_ATTR         2
#define CLASS_MEMBER_TYPE         3

// index into superclass array returned by :classDescribe()
#define CLASS_SUPERCLASS_NAME     1
#define CLASS_SUPERCLASS_ATTR     2
#define CLASS_SUPERCLASS_TYPE     3

// index into method array returned by :classDescribe()
#define CLASS_METHOD_NAME        1
#define CLASS_METHOD_ATTR        2
#define CLASS_METHOD_BLOCK       3
#define CLASS_METHOD_VARNAME     4   // ACCESS/ASSIGN
#define CLASS_METHOD_TYPES       5   // => Array


#define _CLASS_CH
#endif 
