//////////////////////////////////////////////////////////////////////
//
//  COLLAT.CH
//
//  Copyright:
//     Alaska Software, (c) 1996-2023. All rights reserved.         
//  
//  Contents:
//     #define constants for the collation handling SET(_SET_COLLATION, ...)
//   
//  Remarks:
//     When calling the function set(_SET_COLLATION) you should not use 
//     the value defined here directly but only the defined names. The
//     values may change in future versions.
//   
//////////////////////////////////////////////////////////////////////


#ifndef  _COLLAT_CH 

// collat.ch is included
#define  _COLLAT_CH          

#define COLLAT_SYSTEM           0
#define COLLAT_GERMAN           1
#define COLLAT_BRITISH          2
#define COLLAT_AMERICAN         2
#define COLLAT_FINNISH          3
#define COLLAT_FRENCH           4
#define COLLAT_DANISH           5
#define COLLAT_GREEK437         6
#define COLLAT_GREEK851         7
#define COLLAT_ICELANDIC850     8
#define COLLAT_ICELANDIC861     9
#define COLLAT_ITALIAN         10
#define COLLAT_NORWEGIAN       11
#define COLLAT_PORTUGUESE      12
#define COLLAT_SPANISH         13
#define COLLAT_SWEDISH         14
#define COLLAT_DUTCH           15
#define COLLAT_USER            16
#define COLLAT_ASCII           -1   

#define COLLAT_COUNT           17

#define CHARSET_OEM      1
#define CHARSET_ANSI      0

#endif



