// -------------------------------   csFilter   -------------------------------
// definizioni di supporto agli oggetti cs
//

#ifndef  _CSFILTER_CH

// -------------------------------------------------------- BITMAP DEL METER
#define BMP_METER1       1
#define BMP_METER2       2
#define BMP_METER3       3
#define BMP_METER4       4

#define METER_BMP     2400 // num. partenza risorse bitmap
#define BMP_METERON   2461
#define BMP_METEROFF  2462

// -------------------------------------------------------- UTILIZZO DEI FILTRI
#define FLT_AND 1
#define FLT_OR  2

#define FLT_EQUAL       1
#define FLT_NOTEQUAL    2
#define FLT_ELESS       3
#define FLT_LESS        4
#define FLT_GREATHER    5
#define FLT_EGREATHER   6
#define FLT_CONTAIN     7
#define FLT_NOTCONTAIN  8
#define FLT_BETWEEN     9
#define FLT_NOTDEF     10

#define FLT_FROM        6
#define FLT_UNTIL       3


#define FLT_FIELD       1
#define FLT_TYPE        2
#define FLT_VAL         3
#define FLT_BOOLOP      4
#define FLT_UPPER       5

#define CXF             m->xf[select()]   // current xDBF

#command CSFILTER RESET => m->xf\[select()\]:reset()
#command CSCLEARFILTER <nFld> => m->xf\[select()\]:Filter(<nFld>)

#command CSFILTER <nFld> <xType> <x1> [AND] <x2> => m->xf\[select()\]:Filter(<nFld>,<xType>,\{<x1>,<x2>\})
#command CSFILTER <nFld> <xType> <xData> => m->xf\[select()\]:Filter(<nFld>,<xType>,<xData>)
#command CSFILTER <nFld> <xType> AND <xData> => m->xf\[select()\]:Filter(<nFld>,<xType>,<xData>,FLT_AND)
#command CSFILTER <nFld> <xType> OR <xData> => m->xf\[select()\]:Filter(<nFld>,<xType>,<xData>,FLT_OR)

#command CSFILTER <nFld> <aSel> => m->xf\[select()\]:FilterSel(<nFld>,<aSel>)
#command CSFILTER <nFld> RESET  => m->xf\[select()\]:Filter(<nFld>)
#command CSFILTER APPLY => m->xf\[select()\]:apply()
#command CSFILTER CLEAR => m->xf\[select()\]:reset():apply()

#define CSFILTERCHECK m->xf[select()]:CheckScope()

#translate CSFILTER <nFld> =    <xData>  => CSFILTER <nFld> FLT_EQUAL      <xData>
#translate CSFILTER <nFld> ==   <xData>  => CSFILTER <nFld> FLT_EQUAL      <xData>
#translate CSFILTER <nFld> !=   <xData>  => CSFILTER <nFld> FLT_NOTEQUAL   <xData>
#translate CSFILTER <nFld> \<\> <xData>  => CSFILTER <nFld> FLT_NOTEQUAL   <xData>
#translate CSFILTER <nFld> \<=  <xData>  => CSFILTER <nFld> FLT_ELESS      <xData>
#translate CSFILTER <nFld> \<   <xData>  => CSFILTER <nFld> FLT_LESS       <xData>
#translate CSFILTER <nFld> \>   <xData>  => CSFILTER <nFld> FLT_GREATHER   <xData>
#translate CSFILTER <nFld> \>=  <xData>  => CSFILTER <nFld> FLT_EGREATHER  <xData>
#translate CSFILTER <nFld> $    <xData>  => CSFILTER <nFld> FLT_CONTAIN    <xData>
#translate CSFILTER <nFld> !$   <xData>  => CSFILTER <nFld> FLT_NOTCONTAIN <xData>
#translate CSFILTER <nFld> \>\< <xData>  => CSFILTER <nFld> FLT_BETWEEN    <xData>

#translate CSFILTER <nFld> \>\< <xData1> [AND] <xData2> => CSFILTER <nFld> FLT_BETWEEN <xData1> and <xData2>

#define  _CSFILTER_CH
#endif
