* -------------------------------   csUtils   ---------------------------------
* general usage difines
*
*
#ifndef  _CSUTILS_CH

// automatic includes
#include "Common.ch"
#include "Appevent.ch"
#include "Xbp.ch"
#include "Font.ch"
#include "Error.ch"

#pragma Library( "XppUi2.lib" )    // for xbpFileDialog

// ------------------------------------- WINDOWS STYLES AND FIELDS OFFSETS
#define GWL_WNDPROC         (-4)
#define GWL_HINSTANCE       (-6)
#define GWL_HWNDPARENT      (-8)
#define GWL_STYLE           (-16)
#define GWL_EXSTYLE         (-20)
#define GWL_USERDATA        (-21)
#define GWL_ID              (-12)

#define WS_OVERLAPPED       0x00000000
#define WS_POPUP            0x80000000
#define WS_CHILD            0x40000000
#define WS_MINIMIZE         0x20000000
#define WS_VISIBLE          0x10000000
#define WS_DISABLED         0x08000000
#define WS_CLIPSIBLINGS     0x04000000
#define WS_CLIPCHILDREN     0x02000000
#define WS_MAXIMIZE         0x01000000
#define WS_CAPTION          0x00C00000     /* WS_BORDER | WS_DLGFRAME  */
#define WS_BORDER           0x00800000
#define WS_DLGFRAME         0x00400000
#define WS_VSCROLL          0x00200000
#define WS_HSCROLL          0x00100000
#define WS_SYSMENU          0x00080000
#define WS_THICKFRAME       0x00040000
#define WS_GROUP            0x00020000
#define WS_TABSTOP          0x00010000

#define WS_MINIMIZEBOX      0x00020000
#define WS_MAXIMIZEBOX      0x00010000

// -------------------------------------------------------- FOR REGISTRY USAGE
#define HKEY_CLASSES_ROOT           2147483648
#define HKEY_CURRENT_USER           2147483649
#define HKEY_LOCAL_MACHINE          2147483650
#define HKEY_USERS                  2147483651

#define KEY_QUERY_VALUE              1
#define KEY_SET_VALUE                2
#define KEY_CREATE_SUB_KEY           4
#define KEY_ENUMERATE_SUB_KEYS       8
#define KEY_NOTIFY                  16
#define KEY_CREATE_LINK             32
#define KEY_ALL_ACCESS              983103

#define REG_SZ 1

// ------------------------------------------------------- TIMESTAMP XPP STYLE
#define CS_TIMESTAMP DTOS(DATE())+' '+TIME()

// ------------------------------------------------------------- ROUND DEFINES
#define RND_HIGH    1
#define RND_MATH    2
#define RND_LOW     3

// -------------------------------------- SET THE FIRST DOW FOR CSDOW 0=SUNDAY
#define FIRST_DOW   1              // monday

// ------------------------------------------------------------ GENERIC DEFINES
#define MENUITEM_SEPARATOR   {NIL, NIL, XBPMENUBAR_MIS_SEPARATOR, 0}
#define CRLF                 chr(13)+chr(10)
#define TAB                  chr(9)
#define ESC                  chr(27)
#define FF                   chr(12)

// ---------------------------------------------------- ENHANCED SELECT COMMAND
#command SELECT <area> =>  csDbSelectArea( <(area)> )
#command CSSELECT <area> =>  csDbSelectArea( <(area)> )

// ------------------------------------------------------------ ERROR HANDLING
memvar oErr
#command TRY TO <b> => asize( m->ErrStack, len(m->ErrStack)+1 ) ;;
                       m->ErrStack\[len(m->ErrStack)\] := ErrorBlock(<b>) ;;
                       begin sequence
#command TRY        => TRY TO {|e|Break(e)}
#command EXCEPT     => recover using oErr
#command ENDTRY     => endsequence ;;
                       ErrorBlock(m->ErrStack\[len(m->ErrStack)\]) ;;
                       asize( m->ErrStack, len(m->ErrStack)-1 )
#command RAISE      => eval(m->bSelect,m->oErr)


// ----------------------------------------------------------- LOOP DATABASE
#command FOREACH  <alias>  => select <alias> ; GO TOP ; while .not. eof()
#command SKIPTHIS <alias>  => select <alias> ; SKIP ; loop
#command ENDEACH  <alias>  => select <alias> ; SKIP ; end

// ----------------------------------------------------------- LOOP DATABASE
#command RFOREACH  <alias> => select <alias> ; GO BOTTOM ; while .not. bof()
#command RSKIPTHIS <alias> => select <alias> ; SKIP -1 ; loop
#command RENDEACH  <alias> => select <alias> ; SKIP -1 ; end

// ------------------------------------------------------------ REPEAT UNTIL
#xcommand REPEAT       => WHILE .T.
#xcommand UNTIL <exp>  => IF <exp>; EXIT; END; END


#xcommand DEFEMPTY <var1> TO <val1> [,<varN> TO <valN>];
       => IF empty(<var1>) ; <var1> := <val1> ; ENDIF ;
       [; IF empty(<varN>) ; <varN> := <valN> ; ENDIF ]


#xtranslate (<a>[,<b>]) := <f>([<parm,...>]) => A2List( <f>([<parm>]), @<a>[,@<b>] )


#command PROFILER <var>  => _profiler(procname(),procline(),,<var>)
#command PROFILER        => _profiler(procname(),procline())
#command PROFILER START  => _profiler(,,'***start***')
#command PROFILER STOP   => _profiler(,,'PRF'+DTOS(DATE())+'_'+STRTRAN(TIME(),':','')+'.TXT')


#define  _CSUTILS_CH
#endif
