//////////////////////////////////////////////////////////////////////
//
//  DBEDIT.CH
//
//  Copyright:
//      Alaska Software, (c) 1998-2023. All rights reserved.         
//  
//  Contents:
//      #define constants for the DbEdit() user function or
//      the user defined code block
//   
//////////////////////////////////////////////////////////////////////


// Dbedit.ch is not included
#ifndef  _DBEDIT_CH        

*******************************************************************************
* Defines for DbEdit() mode when calling the user function or code block
*******************************************************************************

// Wait for next event
#define  DE_IDLE       0   
// Begin of file was reached already
#define  DE_HITTOP     1   
// End of file was reached already
#define  DE_HITBOTTOM  2   
// Database has no records
#define  DE_EMPTY      3   
// Last event was not processed by DbEdit()
#define  DE_EXCEPT     4   


*******************************************************************************
* Return value of user function or code block
*******************************************************************************

// Terminate DbEdit() 
#define  DE_ABORT      0   
// Continue DbEdit()
#define  DE_CONT       1   
// Refresh screen
#define  DE_REFRESH    2   

// Dbedit.ch is included
#define  _DBEDIT_CH        

#endif                     // #ifndef _DBEDIT_CH

// * EOF *
