//////////////////////////////////////////////////////////////////////
//
//  DBFDBE.CH
//
//  Copyright:
//     Alaska Software, (c) 1995-2023. All rights reserved.         
//  
//  Contents:
//     #define constants for DbeInfo() and DbInfo() of the DBFDBE
//   
//////////////////////////////////////////////////////////////////////


#ifndef  _DBFDBE_CH          
// dbfdbe.ch is not included

// Dmlb.ch is required
#include "dmlb.ch"

// DBFDBE generics
//
#define DBFDBE_MEMOFILE_EXT    DBE_USER+1
#define DBFDBE_MEMOBLOCKSIZE   DBE_USER+2
#define DBFDBE_LOCKMODE        DBE_USER+3
#define DBFDBE_LOCKOFFSET      DBE_USER+4
#define DBFDBE_LOCKDELAY       DBE_USER+5
#define DBFDBE_LOCKRETRY       DBE_USER+6
#define DBFDBE_CACHESIZE       DBE_USER+7
#define DBFDBE_LIFETIME        DBE_USER+8
#define DBFDBE_LOCKDELAY_MIN   DBE_USER+9
#define DBFDBE_LOCKRETRY_MIN   DBE_USER+10
#define DBFDBE_ANSI            DBE_USER+11

// DBO instances of DBFDBE can use:
//
#define DBFDBO_LOCKMODE        DBE_USER+1
#define DBFDBO_LOCKOFFSET      DBE_USER+2
#define DBFDBO_LOCKDELAY       DBE_USER+3
#define DBFDBO_LOCKRETRY       DBE_USER+4
#define DBFDBO_DBFHANDLE       DBE_USER+5
#define DBFDBO_DBTHANDLE       DBE_USER+6
#define DBFDBO_ANSI            DBE_USER+7

// DBE Lock-Modus defines
//
// Clipper compatibility level
#define DBF_NOLOCK             1      

// enhanced OS/2 mode performs autolocking for
// append, read/write, delete, recall
#define DBF_AUTOLOCK           2      

// dbfdbe.ch is included
#define  _DBFDBE_CH         

#endif                    // #ifndef _DBFDBE_CH



