//////////////////////////////////////////////////////////////////////
//
//  EXTERN.CH
//
//  Copyright:
//     Alaska Software, (c) 2002-2023. All rights reserved.         
//  
//  Contents:
//     EXTERN-Befehl fr den Aufruf von Nicht-Xbase++ DLLs.
//   
//////////////////////////////////////////////////////////////////////


#ifndef _EXTERN_HEADER_DAEMON
#define _EXTERN_HEADER_DAEMON

// EXTERN command with parameters in the function call.
#command EXTERN [<xCallConv:CDECL, STDCALL>] ;
        [<xRetType:SHORT, USHORT, INTEGER, UINTEGER, LONG, BOOL, BOOL8, INTEGER64, UINTEGER64, SINGLE, DOUBLE, STRING, WSTRING, IDISPATCH>];
        <FuncName>( [<paramVal1> AS <paramType1> [,<paramValN> AS <paramTypeN>]] );
        IN <LibraryName> [NAME <AliasName>];
        => FUNCTION <FuncName>( <paramVal1>[,<paramValN>] )                   ;;
                STATIC template := NIL                                        ;;
                LOCAL xRet                                                    ;;
                IF template == NIL                                            ;;
                   template:=DllPrepareCall(<(LibraryName)>,Coalesce(__Sys( <xCallConv> ), DLL_STDCALL)+Coalesce(__Sys(<xRetType>),DLL_TYPE_INT32)+DLL_CALLMODE_COPY+DLL_CALLMODE_RESTOREFPU,Coalesce(<(AliasName)>,<(FuncName)>),__Sys(<paramType1>)[,__Sys(<paramTypeN>)]) ;;
                 ENDIF                                                        ;;
                xRet := DllExecuteCall( template,<paramVal1>[,<paramValN>] )  ;;
             RETURN xRet

#command STATIC EXTERN [<xCallConv:CDECL, STDCALL>] ;
        [<xRetType:SHORT, USHORT, INTEGER, UINTEGER, LONG, BOOL, BOOL8, INTEGER64, UINTEGER64, SINGLE, DOUBLE, STRING, WSTRING, IDISPATCH>];
        <FuncName>( [<paramVal1> AS <paramType1> [,<paramValN> AS <paramTypeN>]] );
        IN <LibraryName> [NAME <AliasName>];
        => STATIC FUNCTION <FuncName>( <paramVal1>[,<paramValN>] )            ;;
                STATIC template := NIL                                        ;;
                LOCAL xRet                                                    ;;
                IF template == NIL                                            ;;
                   template:=DllPrepareCall(<(LibraryName)>,Coalesce(__Sys( <xCallConv> ), DLL_STDCALL)+Coalesce(__Sys(<xRetType>),DLL_TYPE_INT32)+DLL_CALLMODE_COPY+DLL_CALLMODE_RESTOREFPU,Coalesce(<(AliasName)>,<(FuncName)>),__Sys(<paramType1>)[,__Sys(<paramTypeN>)]) ;;
                 ENDIF                                                        ;;
                xRet := DllExecuteCall( template,<paramVal1>[,<paramValN>] )  ;;
             RETURN xRet

// EXTERN command without parameters in the function call.
#command EXTERN [<xCallConv:CDECL, STDCALL>] ;
        [<xRetType:SHORT, USHORT, INTEGER, UINTEGER, LONG, BOOL, BOOL8, INTEGER64, UINTEGER64, SINGLE, DOUBLE, STRING, WSTRING, IDISPATCH>];
        <FuncName>() IN <LibraryName> [NAME <AliasName>] ;
        => FUNCTION <FuncName>()                            ;;
                STATIC template := NIL                      ;;
                LOCAL xRet                                  ;;
                IF template == NIL                          ;;
                   template:=DllPrepareCall(<(LibraryName)>,Coalesce(__Sys( <xCallConv> ), DLL_STDCALL)+Coalesce(__Sys(<xRetType>),DLL_TYPE_INT32)+DLL_CALLMODE_COPY+DLL_CALLMODE_RESTOREFPU,Coalesce(<(AliasName)>,<(FuncName)>)) ;;
                ENDIF                                       ;;
                xRet := DllExecuteCall( template )          ;;
             RETURN xRet

#command STATIC EXTERN [<xCallConv:CDECL, STDCALL>] ;
        [<xRetType:SHORT, USHORT, INTEGER, UINTEGER, LONG, BOOL, BOOL8, INTEGER64, UINTEGER64, SINGLE, DOUBLE, STRING, WSTRING, IDISPATCH>];
        <FuncName>() IN <LibraryName> [NAME <AliasName>] ;
        => STATIC FUNCTION <FuncName>()            ;;
                STATIC template := NIL             ;;
                LOCAL xRet                         ;;
                IF template == NIL                 ;;
                   template:=DllPrepareCall(<(LibraryName)>,Coalesce(__Sys( <xCallConv> ), DLL_STDCALL)+Coalesce(__Sys(<xRetType>),DLL_TYPE_INT32)+DLL_CALLMODE_COPY+DLL_CALLMODE_RESTOREFPU,Coalesce(<(AliasName)>,<(FuncName)>)) ;;
                ENDIF                              ;;
                xRet := DllExecuteCall( template ) ;;
             RETURN xRet

#xtrans __Sys( SHORT )      => DLL_TYPE_INT16
#xtrans __Sys( USHORT )     => DLL_TYPE_UINT16
#xtrans __Sys( INTEGER )    => DLL_TYPE_INT32
#xtrans __Sys( LONG )       => DLL_TYPE_INT32
#xtrans __Sys( UINTEGER )   => DLL_TYPE_UINT32
#xtrans __Sys( BOOL8 )      => DLL_TYPE_BOOL8
#xtrans __Sys( BOOL )       => DLL_TYPE_BOOL32
#xtrans __Sys( INTEGER64 )  => DLL_TYPE_INT64
#xtrans __Sys( UINTEGER64 ) => DLL_TYPE_UINT64
#xtrans __Sys( SINGLE )     => DLL_TYPE_FLOAT32
#xtrans __Sys( DOUBLE )     => DLL_TYPE_FLOAT64
#xtrans __Sys( STRING )     => DLL_TYPE_STRING
#xtrans __Sys( WSTRING )    => DLL_TYPE_WSTRING
#xtrans __Sys( IDISPATCH )  => DLL_TYPE_IDISPATCH
#xtrans __Sys( CALLBACK )   => DLL_TYPE_CALLBACK
#xtrans __Sys( ACALLBACK )  => DLL_TYPE_ACALLBACK
#xtrans __Sys( XPPVALUE )   => DLL_TYPE_XPPVALUE
#xtrans __Sys( STRUCTURE )  => DLL_TYPE_STRUCTURE
#xtrans __Sys()             => NIL

#endif // _EXTERN_HEADER_DAEMON
