//////////////////////////////////////////////////////////////////////
//
//  FONT.CH
//
//  Copyright:
//       Alaska Software, (c) 1998-2023. All rights reserved.         
//  
//  Contents:
//       Constants for operating system-independent font names
//   
//  Remarks:
//       Automatic font mapping between OS/2 and Windows
//        OS/2 font name             Windows font name
//        Courier                    Courier
//        Helv                       Helv
//        Roman                      Roman
//        Symbol                     Symbol
//        Times New Roman            Times New Roman
//        Tms Rmn                    Tms Rmn
//    
//       Recommended font mapping between OS/2 and Windows
//    
//        OS/2 font name             Windows font name
//        Helvetica                  Arial
//        Swiss                      Arial
//        Symbol Set                 Symbol
//        System Monospaced          Terminal
//        System Monospaced          Lucida Console
//        System Proportional        MS Sans Serif
//        System Proportional        MS Serif
//        System VIO                 Small Fonts
//        System VIO                 System
//        System VIO                 Terminal
//   
//////////////////////////////////////////////////////////////////////


#ifndef _FONT_CH

#include "natMsg.ch"


/*
 * Font style modifiers
 */
#define  FONT_STYLE_BOLD         nationMsg( NAT_MSG_FNT_STYLE_BOLD     )
#define  FONT_STYLE_ITALIC       nationMsg( NAT_MSG_FNT_STYLE_ITALIC   )

/*
 * Platform-independent font names defined
 */
#define  FONT_DEFFIXED_SMALL     nationMsg( NAT_MSG_FNT_FIXED_SMALL    )
#define  FONT_DEFFIXED_MEDIUM    nationMsg( NAT_MSG_FNT_FIXED_MEDIUM   )
#define  FONT_DEFFIXED_LARGE     nationMsg( NAT_MSG_FNT_FIXED_LARGE    )
#define  FONT_DEFFIXED_XLARGE    nationMsg( NAT_MSG_FNT_FIXED_XLARGE   )

#define  FONT_DEFPROP_SMALL      nationMsg( NAT_MSG_FNT_PROP_SMALL     )
#define  FONT_DEFPROP_MEDIUM     nationMsg( NAT_MSG_FNT_PROP_MEDIUM    )
#define  FONT_DEFPROP_LARGE      nationMsg( NAT_MSG_FNT_PROP_LARGE     )
#define  FONT_DEFPROP_XLARGE     nationMsg( NAT_MSG_FNT_PROP_XLARGE    )

#define  FONT_HELV_SMALL         nationMsg( NAT_MSG_FNT_HELV_SMALL     )
#define  FONT_HELV_MEDIUM        nationMsg( NAT_MSG_FNT_HELV_MEDIUM    )
#define  FONT_HELV_LARGE         nationMsg( NAT_MSG_FNT_HELV_LARGE     )
#define  FONT_HELV_XLARGE        nationMsg( NAT_MSG_FNT_HELV_XLARGE    )

#define  FONT_COURIER_SMALL      nationMsg( NAT_MSG_FNT_COURIER_SMALL  )
#define  FONT_COURIER_MEDIUM     nationMsg( NAT_MSG_FNT_COURIER_MEDIUM )
#define  FONT_COURIER_LARGE      nationMsg( NAT_MSG_FNT_COURIER_LARGE  )
#define  FONT_COURIER_XLARGE     nationMsg( NAT_MSG_FNT_COURIER_XLARGE )

#define  FONT_TIMES_SMALL        nationMsg( NAT_MSG_FNT_TIMES_SMALL    )
#define  FONT_TIMES_MEDIUM       nationMsg( NAT_MSG_FNT_TIMES_MEDIUM   )
#define  FONT_TIMES_LARGE        nationMsg( NAT_MSG_FNT_TIMES_LARGE    )
#define  FONT_TIMES_XLARGE       nationMsg( NAT_MSG_FNT_TIMES_XLARGE   )

#define _FONT_CH

#endif   // _FONT_CH
