//////////////////////////////////////////////////////////////////////
//
//  FOXDBE.CH
//
//  Copyright:
//     Alaska Software, (c) 1997-2023. All rights reserved.         
//  
//  Contents:
//     #define constants for DbeInfo() and DbInfo() of the FOXDBE
//   
//////////////////////////////////////////////////////////////////////


#ifndef  _FOXDBE_CH          
// foxdbe.ch is not included

// Dmlb.ch is required
#include "dmlb.ch"           

// FOXDBE generics
//
#define FOXDBE_MEMOFILE_EXT    DBE_USER+1
#define FOXDBE_MEMOBLOCKSIZE   DBE_USER+2
#define FOXDBE_LOCKOFFSET      DBE_USER+3
#define FOXDBE_LOCKDELAY       DBE_USER+4
#define FOXDBE_LOCKRETRY       DBE_USER+5
#define FOXDBE_CACHESIZE       DBE_USER+6
#define FOXDBE_LIFETIME        DBE_USER+7
#define FOXDBE_LOCKDELAY_MIN   DBE_USER+8
#define FOXDBE_LOCKRETRY_MIN   DBE_USER+9
#define FOXDBE_LOCKMODE        DBE_USER+10
#define FOXDBE_CREATE_2X       DBE_USER+11

#define FOXDBE_LOCKMODE_AUTO    DBE_USER+1
#define FOXDBE_LOCKMODE_2X      DBE_USER+2
#define FOXDBE_LOCKMODE_VISUAL  DBE_USER+3
#define FOXDBE_LOCKMODE_CLIPPER DBE_USER+4

       

// DBO instances of FOXDBE can use:
//
#define FOXDBO_LOCKOFFSET      DBE_USER+1
#define FOXDBO_LOCKDELAY       DBE_USER+2
#define FOXDBO_LOCKRETRY       DBE_USER+3
#define FOXDBO_MEMOBLOCKSIZE   DBE_USER+4
#define FOXDBO_LOCKDELAY_MIN   DBE_USER+5
#define FOXDBO_LOCKRETRY_MIN   DBE_USER+6
#define FOXDBO_CODEPAGE        DBE_USER+7

// FLD_ defines to be used with FieldInfo()
//
#define FOXFLD_READONLY           DBE_USER+1
#define FOXFLD_SEQUENCE_NEXTVAL   DBE_USER+2

// foxdbe.ch is included
#define  _FOXDBE_CH         

#endif                      // #ifndef _FOXDBE_CH



