//////////////////////////////////////////////////////////////////////
//
//  GRA.CH
//
//  Copyright:
//      Alaska Software, (c) 1998-2023. All rights reserved.         
//  
//  Contents:
//      #defines for the GRA engine
//   
//////////////////////////////////////////////////////////////////////


// Gra.ch is not included
#ifndef  _GRA_CH                       

//****************************************************************************
// Fill options for GraBox() and GraArc()
//****************************************************************************
#define  GRA_FILL                      1
#define  GRA_OUTLINE                   2
#define  GRA_OUTLINEFILL               3

//****************************************************************************
// Rectangle styles for GraDrawEdge() 
//****************************************************************************
#define  GRA_EDGESTYLE_SIMPLE           2
#define  GRA_EDGESTYLE_SUNKEN           10
#define  GRA_EDGESTYLE_RAISED           5

//---------------------------------------------------------------------------
// Edge elements for GraDrawEdge() 
//---------------------------------------------------------------------------
#define GRA_EDGEELEMS_LEFT              1
#define GRA_EDGEELEMS_TOP               2
#define GRA_EDGEELEMS_RIGHT             4
#define GRA_EDGEELEMS_BOTTOM            8
#define GRA_EDGEELEMS_RECT              0xF
#define GRA_EDGEELEMS_FILLEDRECT        0x800  + GRA_EDGEELEMS_RECT 
#define GRA_EDGEELEMS_FLATRECT          0x4000 + GRA_EDGEELEMS_RECT
#define GRA_EDGEELEMS_RECTMONO          0x8000 + GRA_EDGEELEMS_RECT

//****************************************************************************
// Array indexes for area attributes: GraSetAttrArea()
//****************************************************************************
#define  GRA_AA_COLOR                  1
#define  GRA_AA_BACKCOLOR              2
#define  GRA_AA_MIXMODE                3
#define  GRA_AA_BGMIXMODE              4
#define  GRA_AA_SYMBOL                 5

#define  GRA_AA_COUNT                  5

//---------------------------------------------------------------------------
// Fill attributes for GRA_AA_SYMBOL of GraSetAttrArea()
//---------------------------------------------------------------------------

#ifdef __OS2__
#define  GRA_SYM_DENSE1                1
#define  GRA_SYM_DENSE2                2
#define  GRA_SYM_DENSE3                3
#define  GRA_SYM_DENSE4                4
#define  GRA_SYM_DENSE5                5
#define  GRA_SYM_DENSE6                6
#define  GRA_SYM_DENSE7                7
#define  GRA_SYM_DENSE8                8
#define  GRA_SYM_VERT                  9
#define  GRA_SYM_HORIZ                10
#define  GRA_SYM_DIAG1                11
#define  GRA_SYM_DIAG2                12
#define  GRA_SYM_DIAG3                13
#define  GRA_SYM_DIAG4                14
#define  GRA_SYM_NOSHADE              15
#define  GRA_SYM_SOLID                16
#define  GRA_SYM_HALFTONE             17
#define  GRA_SYM_HATCH                18
#define  GRA_SYM_DIAGHATCH            19
#define  GRA_SYM_BLANK                64
#endif

#ifdef __WIN32__
#define  GRA_SYM_DENSE1             1000
#define  GRA_SYM_DENSE2             1001
#define  GRA_SYM_DENSE3             1002
#define  GRA_SYM_DENSE4             1003  
#define  GRA_SYM_DENSE5             1004  
#define  GRA_SYM_DENSE6             1005  
#define  GRA_SYM_DENSE7             1006  
#define  GRA_SYM_DENSE8             1007  
#define  GRA_SYM_VERT             131073
#define  GRA_SYM_HORIZ            131072
#define  GRA_SYM_DIAG1            131075
#define  GRA_SYM_DIAG2              1008
#define  GRA_SYM_DIAG3            131074
#define  GRA_SYM_DIAG4              1009    
#define  GRA_SYM_NOSHADE           65536
#define  GRA_SYM_SOLID                 0
#define  GRA_SYM_HALFTONE           1010    
#define  GRA_SYM_HATCH            131076
#define  GRA_SYM_DIAGHATCH        131077
#define  GRA_SYM_BLANK             65536
#endif

#define  GRA_SYM_DEFAULT              GRA_SYM_SOLID

//****************************************************************************
// Array indexes for marker attributes: GraSetAttrMarker()
//****************************************************************************
#define  GRA_AM_COLOR                  1
#define  GRA_AM_BACKCOLOR              2
#define  GRA_AM_MIXMODE                3
#define  GRA_AM_BGMIXMODE              4
#define  GRA_AM_SYMBOL                 5
#define  GRA_AM_BOX                    6

#define  GRA_AM_COUNT                  6

//---------------------------------------------------------------------------
// Marker symbols for GRA_AM_SYMBOL of GraSetAttrMarker()
//---------------------------------------------------------------------------

#define  GRA_MARKSYM_CROSS             1
#define  GRA_MARKSYM_PLUS              2
#define  GRA_MARKSYM_DIAMOND           3
#define  GRA_MARKSYM_SQUARE            4
#define  GRA_MARKSYM_SIXPOINTSTAR      5
#define  GRA_MARKSYM_EIGHTPOINTSTAR    6
#define  GRA_MARKSYM_SOLIDDIAMOND      7
#define  GRA_MARKSYM_SOLIDSQUARE       8
#define  GRA_MARKSYM_DOT               9
#define  GRA_MARKSYM_SMALLCIRCLE      10
#define  GRA_MARKSYM_BLANK            64

#define  GRA_MARKSYM_DEFAULT           GRA_MARKSYM_CROSS


//****************************************************************************
// Array indexes for line attributes: GraSetAttrLine()
//****************************************************************************
#define  GRA_AL_COLOR                  1
#define  GRA_AL_MIXMODE                2
#define  GRA_AL_WIDTH                  3
#define  GRA_AL_TYPE                   4

#define  GRA_AL_COUNT                  4

//---------------------------------------------------------------------------
// Line types for GRA_AL_TYPE of GraSetAttrLine()
//---------------------------------------------------------------------------

#ifdef __OS2__
#define  GRA_LINETYPE_DOT              1
#define  GRA_LINETYPE_SHORTDASH        2
#define  GRA_LINETYPE_DASHDOT          3
#define  GRA_LINETYPE_DOUBLEDOT        4
#define  GRA_LINETYPE_LONGDASH         5
#define  GRA_LINETYPE_DASHDOUBLEDOT    6
#define  GRA_LINETYPE_SOLID            7
#define  GRA_LINETYPE_INVISIBLE        8
#define  GRA_LINETYPE_ALTERNATE        9
#endif

#ifdef __WIN32__
#define  GRA_LINETYPE_DOT              2
#define  GRA_LINETYPE_SHORTDASH        1 
#define  GRA_LINETYPE_DASHDOT          3
#define  GRA_LINETYPE_DOUBLEDOT        GRA_LINETYPE_DOT
#define  GRA_LINETYPE_LONGDASH         GRA_LINETYPE_SHORTDASH
#define  GRA_LINETYPE_DASHDOUBLEDOT    4
#define  GRA_LINETYPE_SOLID            0
#define  GRA_LINETYPE_INVISIBLE        5
#define  GRA_LINETYPE_ALTERNATE        GRA_LINETYPE_DASHDOT
#endif

#define  GRA_LINETYPE_DEFAULT          GRA_LINETYPE_SOLID

//---------------------------------------------------------------------------
// Line width for GRA_AL_WIDTH of GraSetAttrLine()
//---------------------------------------------------------------------------

#ifdef __OS2__
#define  GRA_LINEWIDTH_NORMAL          1
#define  GRA_LINEWIDTH_THICK           2
#endif

#ifdef __WIN32__
#define  GRA_LINEWIDTH_NORMAL          0
#define  GRA_LINEWIDTH_THICK           2                              
#endif

#define  GRA_LINEWIDTH_DEFAULT         GRA_LINEWIDTH_NORMAL

//****************************************************************************
// Array indexes for string attributes: GraSetAttrString()
//****************************************************************************
#define  GRA_AS_COLOR                  1
#define  GRA_AS_BACKCOLOR              2
#define  GRA_AS_MIXMODE                3
#define  GRA_AS_BGMIXMODE              4
#define  GRA_AS_BOX                    5
#define  GRA_AS_ANGLE                  6
#define  GRA_AS_SHEAR                  7
#define  GRA_AS_DIRECTION              8
#define  GRA_AS_HORIZALIGN             9
#define  GRA_AS_VERTALIGN             10
#define  GRA_AS_EXTRA                 11
#define  GRA_AS_BREAK_EXTRA           12

#define  GRA_AS_COUNT                 12

//---------------------------------------------------------------------------
// Output direction for GRA_AS_DIRECTION of GraSetAttrString()
//---------------------------------------------------------------------------

#define  GRA_CHDIRN_LEFTRIGHT          1
#define  GRA_CHDIRN_TOPBOTTOM          2
#define  GRA_CHDIRN_RIGHTLEFT          3
#define  GRA_CHDIRN_BOTTOMTOP          4

#define  GRA_CHDIRN_DEFAULT            GRA_CHDIRN_LEFTRIGHT

//---------------------------------------------------------------------------
// Horizontal alignment for GRA_AS_HORIZALIGN of GraSetAttrString()
//---------------------------------------------------------------------------

#ifdef __OS2__
#define  GRA_HALIGN_NORMAL             1
#define  GRA_HALIGN_LEFT               2
#define  GRA_HALIGN_CENTER             3
#define  GRA_HALIGN_RIGHT              4
#define  GRA_HALIGN_STANDARD           5
#endif

#ifdef __WIN32__
#define  GRA_HALIGN_LEFT               0
#define  GRA_HALIGN_CENTER             6
#define  GRA_HALIGN_RIGHT              2
#define  GRA_HALIGN_STANDARD           GRA_HALIGN_LEFT
#define  GRA_HALIGN_NORMAL             GRA_HALIGN_LEFT
#endif

//---------------------------------------------------------------------------
// Vertical alignment for GRA_AS_VERTALIGN of GraSetAttrString()
//---------------------------------------------------------------------------

#ifdef __OS2__
#define  GRA_VALIGN_NORMAL             1
#define  GRA_VALIGN_TOP                2
#define  GRA_VALIGN_HALF               3
#define  GRA_VALIGN_BASE               4 
#define  GRA_VALIGN_BOTTOM             5 
#define  GRA_VALIGN_STANDARD           6 
#endif

#ifdef __WIN32__
#define  GRA_VALIGN_TOP                0
#define  GRA_VALIGN_HALF               -1
#define  GRA_VALIGN_BASE               24 
#define  GRA_VALIGN_BOTTOM             8 
#define  GRA_VALIGN_STANDARD           GRA_VALIGN_BASE 
#define  GRA_VALIGN_NORMAL             GRA_VALIGN_BASE
#endif

//****************************************************************************
// Foreground color mix attributes for GRA_A?_MIXMODE of the attribute arrays
//****************************************************************************
#ifdef __OS2__
#define  GRA_FGMIX_OR                  1
#define  GRA_FGMIX_OVERPAINT           2
#define  GRA_FGMIX_LEAVEALONE          5
#define  GRA_FGMIX_XOR                 4
#define  GRA_FGMIX_AND                 6
#define  GRA_FGMIX_SUBTRACT            7
#define  GRA_FGMIX_MASKSRCNOT          8
#define  GRA_FGMIX_ZERO                9
#define  GRA_FGMIX_NOTMERGESRC        10
#define  GRA_FGMIX_NOTXORSRC          11
#define  GRA_FGMIX_INVERT             12
#define  GRA_FGMIX_MERGESRCNOT        13
#define  GRA_FGMIX_NOTCOPYSRC         14
#define  GRA_FGMIX_MERGENOTSRC        15
#define  GRA_FGMIX_NOTMASKSRC         16
#define  GRA_FGMIX_ONE                17
#endif

#ifdef __WIN32__
#define  GRA_FGMIX_OR                 15
#define  GRA_FGMIX_OVERPAINT          13
#define  GRA_FGMIX_LEAVEALONE         11
#define  GRA_FGMIX_XOR                7
#define  GRA_FGMIX_AND                9
#define  GRA_FGMIX_SUBTRACT           3
#define  GRA_FGMIX_MASKSRCNOT         5
#define  GRA_FGMIX_ZERO               1
#define  GRA_FGMIX_NOTMERGESRC        2
#define  GRA_FGMIX_NOTXORSRC          10
#define  GRA_FGMIX_INVERT             6
#define  GRA_FGMIX_MERGESRCNOT        14
#define  GRA_FGMIX_NOTCOPYSRC         4
#define  GRA_FGMIX_MERGENOTSRC        12
#define  GRA_FGMIX_NOTMASKSRC         8
#define  GRA_FGMIX_ONE                16
#endif

#define  GRA_FGMIX_DEFAULT            GRA_FGMIX_OVERPAINT

//****************************************************************************
// Background color mix attributes for GRA_A?_BGMIXMODE of the attribute arrays
//****************************************************************************
#ifdef __OS2__
#define  GRA_BGMIX_OVERPAINT           2
#define  GRA_BGMIX_LEAVEALONE          4
#define  GRA_BGMIX_OR                  1
#define  GRA_BGMIX_XOR                 3
#endif

#ifdef __WIN32__
#define  GRA_BGMIX_OVERPAINT           2
#define  GRA_BGMIX_LEAVEALONE          1        
#define  GRA_BGMIX_OR                  GRA_BGMIX_LEAVEALONE
#define  GRA_BGMIX_XOR                 GRA_BGMIX_LEAVEALONE
#endif

#define  GRA_BGMIX_DEFAULT             GRA_BGMIX_LEAVEALONE

//****************************************************************************
// Color attributes for GRA_A?_COLOR and GRA_A?_BGCOLOR in the attribute
// arrays and for the function GraSetColor()
//****************************************************************************
#ifdef __OS2__
#define  GRA_CLR_FALSE               (-5)
#define  GRA_CLR_TRUE                (-4)
#define  GRA_CLR_DEFAULT             (-3)
#define  GRA_CLR_WHITE               (-2)
#define  GRA_CLR_BLACK               (-1)
#define  GRA_CLR_BACKGROUND            0
#define  GRA_CLR_BLUE                  1
#define  GRA_CLR_RED                   2
#define  GRA_CLR_PINK                  3
#define  GRA_CLR_GREEN                 4
#define  GRA_CLR_CYAN                  5
#define  GRA_CLR_YELLOW                6
#define  GRA_CLR_NEUTRAL               7
#define  GRA_CLR_DARKGRAY              8
#define  GRA_CLR_DARKBLUE              9
#define  GRA_CLR_DARKRED              10
#define  GRA_CLR_DARKPINK             11
#define  GRA_CLR_DARKGREEN            12
#define  GRA_CLR_DARKCYAN             13
#define  GRA_CLR_BROWN                14
#define  GRA_CLR_PALEGRAY             15
#endif

#ifdef __WIN32__
#define  GRA_CLR_FALSE               (-5)
#define  GRA_CLR_TRUE                (-4)
#define  GRA_CLR_DEFAULT             (-3)
#define  GRA_CLR_BACKGROUND          (-2)
#define  GRA_CLR_NEUTRAL             (-1)
#define  GRA_CLR_WHITE                 0
#define  GRA_CLR_BLACK                 1
#define  GRA_CLR_BLUE                  2
#define  GRA_CLR_RED                   3
#define  GRA_CLR_PINK                  4
#define  GRA_CLR_GREEN                 5
#define  GRA_CLR_CYAN                  6
#define  GRA_CLR_YELLOW                7
#define  GRA_CLR_DARKGRAY              8
#define  GRA_CLR_DARKBLUE              9
#define  GRA_CLR_DARKRED              10
#define  GRA_CLR_DARKPINK             11
#define  GRA_CLR_DARKGREEN            12
#define  GRA_CLR_DARKCYAN             13
#define  GRA_CLR_BROWN                14
#define  GRA_CLR_PALEGRAY             15
#endif

#define GRA_CLR_INVALID               -6

#define  GRA_NUMCLR_RESERVED          15

//****************************************************************************
// Defines for graphic segments
//****************************************************************************

//---------------------------------------------------------------------------
// Segment modes for GraSegOpen()
//---------------------------------------------------------------------------

#define  GRA_SEG_MODIFIABLE            1
#define  GRA_SEG_NIL                   2

//---------------------------------------------------------------------------
// Priority for GraSetSegPriority()
//---------------------------------------------------------------------------

#define  GRA_SEG_LOWER_PRI           (-1)
#define  GRA_SEG_HIGHER_PRI            1

//---------------------------------------------------------------------------
// Drawing modes for GraSegDrawMode()
//---------------------------------------------------------------------------

#define  GRA_DM_DRAW                   1
#define  GRA_DM_RETAIN                 2
#define  GRA_DM_DRAWANDRETAIN          3

//---------------------------------------------------------------------------
// Modes for graphic transformations with GraRotate(),GraScale(),GraTranslate()
// and XbpPresSpace():setGraTransform()
//---------------------------------------------------------------------------

#define  GRA_TRANSFORM_REPLACE         0
#define  GRA_TRANSFORM_ADD             1
#define  GRA_TRANSFORM_PREEMPT         2

//---------------------------------------------------------------------------
// Options for drawing operations, eg. GraSegDraw()
//---------------------------------------------------------------------------

#define  GRA_DRAW_NONBUFFERED          0
#define  GRA_DRAW_BUFFERED             4

//---------------------------------------------------------------------------
// Initial transformation matrix
//---------------------------------------------------------------------------

#ifdef __XPP__
#ifdef __OS2__
#xtranslate  GraInitMatrix()  =>  { {65536,0,0}, {0,65536,0}, {0,0,1} }
#endif

#ifdef __WIN32__
#xtranslate  GraInitMatrix()  =>  { {1.0,0.0,0.0}, {0.0,1.0,0.0}, {0.0,0.0,1.0} }
#endif
#endif

//****************************************************************************
// Defines for graphic paths
//****************************************************************************

//---------------------------------------------------------------------------
// Modes for GraPathFill()
//---------------------------------------------------------------------------

#ifdef __OS2__
#define  GRA_PATH_FILL_ALTERNATE       1
#define  GRA_PATH_FILL_WINDING         2
#define  GRA_PATH_FILL_EXCL            8
#endif

#ifdef __WIN32__
#define  GRA_PATH_FILL_ALTERNATE       1
#define  GRA_PATH_FILL_WINDING         2
#define  GRA_PATH_FILL_EXCL            GRA_PATH_FILL_ALTERNATE
#endif

//---------------------------------------------------------------------------
// Modes for GraPathClip()
//---------------------------------------------------------------------------

#define  GRA_PATH_CLIP_ALTERNATE       0
#define  GRA_PATH_CLIP_WINDING         2
#define  GRA_PATH_CLIP_INCL            0
#define  GRA_PATH_CLIP_EXCL            8
#ifdef __WIN32__
#define  GRA_PATH_CLIP_COMBINE         4
#endif

//****************************************************************************
// Defines for the function GraBitBlt()
//****************************************************************************

//---------------------------------------------------------------------------
// Raster operations
//---------------------------------------------------------------------------

#ifdef __OS2__
#define  GRA_BLT_ROP_SRCCOPY          204  // 0x00CCL
#define  GRA_BLT_ROP_SRCPAINT         238  // 0x00EEL
#define  GRA_BLT_ROP_SRCAND           136  // 0x0088L
#define  GRA_BLT_ROP_SRCINVERT        102  // 0x0066L
#define  GRA_BLT_ROP_SRCERASE          68  // 0x0044L
#define  GRA_BLT_ROP_NOTSRCCOPY        51  // 0x0033L
#define  GRA_BLT_ROP_NOTSRCERASE       17  // 0x0011L
#define  GRA_BLT_ROP_MERGECOPY        192  // 0x00C0L
#define  GRA_BLT_ROP_MERGEPAINT       187  // 0x00BBL
#define  GRA_BLT_ROP_PATCOPY          240  // 0x00F0L
#define  GRA_BLT_ROP_PATPAINT         251  // 0x00FBL
#define  GRA_BLT_ROP_PATINVERT         90  // 0x005AL
#define  GRA_BLT_ROP_DSTINVERT         85  // 0x0055L
#define  GRA_BLT_ROP_ZERO               0  // 0x0000L
#define  GRA_BLT_ROP_ONE              255  // 0x00FFL
#endif

#ifdef __WIN32__
#define  GRA_BLT_ROP_SRCCOPY         13369376
#define  GRA_BLT_ROP_SRCPAINT        15597702
#define  GRA_BLT_ROP_SRCAND           8913094
#define  GRA_BLT_ROP_SRCINVERT        6684742
#define  GRA_BLT_ROP_SRCERASE         4457256
#define  GRA_BLT_ROP_NOTSRCCOPY       3342344
#define  GRA_BLT_ROP_NOTSRCERASE      1114278
#define  GRA_BLT_ROP_MERGECOPY       12583114
#define  GRA_BLT_ROP_MERGEPAINT      12255782
#define  GRA_BLT_ROP_PATCOPY         15728673
#define  GRA_BLT_ROP_PATPAINT        16452105
#define  GRA_BLT_ROP_PATINVERT        5898313
#define  GRA_BLT_ROP_DSTINVERT        5570569
#define  GRA_BLT_ROP_ZERO                  66
#define  GRA_BLT_ROP_ONE             16711778
#endif


//---------------------------------------------------------------------------
// Bit blitting
//---------------------------------------------------------------------------

#ifdef __OS2__
#define  GRA_BLT_BBO_OR                 0
#define  GRA_BLT_BBO_AND                1
#define  GRA_BLT_BBO_IGNORE             2
#endif

#ifdef __WIN32__
#define  GRA_BLT_BBO_OR                 2
#define  GRA_BLT_BBO_AND                1
#define  GRA_BLT_BBO_IGNORE             3
#endif


//****************************************************************************
// Defines for the function GraGradientFill()
//****************************************************************************
#define  GRA_GRADIENT_HORIZONTAL        0
#define  GRA_GRADIENT_VERTICAL          1
#define  GRA_GRADIENT_TRIANGLE          2


//****************************************************************************
// Presentation Space
//****************************************************************************

//---------------------------------------------------------------------------
// Page units for XbpPresSpace:setPageSize()
//---------------------------------------------------------------------------
#define  GRA_PU_ARBITRARY               4
#define  GRA_PU_PIXEL                   8
#define  GRA_PU_LOMETRIC               12
#define  GRA_PU_HIMETRIC               16
#define  GRA_PU_LOENGLISH              20
#define  GRA_PU_HIENGLISH              24
#define  GRA_PU_TWIPS                  28
#define  GRA_PU_TEXT                   32

#define  GRA_PO_TOPLEFT                1
#define  GRA_PO_BOTTOMLEFT             2

//---------------------------------------------------------------------------
// Modes supported by the XbpPresSpace class
//---------------------------------------------------------------------------
#define XBPPS_MODE_NORMAL                0
#define XBPPS_MODE_HIGH_TXT_PRECISION    1

#define XBPPS_MODE_HIGH_PRECISION        XBPPS_MODE_HIGH_TXT_PRECISION

//---------------------------------------------------------------------------
// Defines for XbpPresSpace:lockHDC()
//---------------------------------------------------------------------------
#define GRA_LOCKHDC_ENUMDEVS             0x1000
#define GRA_LOCKHDC_LINEATTRS            (0x0001+GRA_LOCKHDC_ENUMDEVS)
#define GRA_LOCKHDC_AREAATTRS            (0x0002+GRA_LOCKHDC_ENUMDEVS)
#define GRA_LOCKHDC_STRINGATTRS          (0x0004+GRA_LOCKHDC_ENUMDEVS)
#define GRA_LOCKHDC_MARKERATTRS          (0x0008+GRA_LOCKHDC_ENUMDEVS)


//****************************************************************************
// Color modes defined for usage with SET( _SET_COLORMODE )
//****************************************************************************
#define GRA_CLRMODE_COMPATIBLE           0
#define GRA_CLRMODE_STANDARD             1
#define GRA_CLRMODE_DEFCOLORTAB          3
#define GRA_CLRMODE_DITHER               8

// Gra.ch is included
#define _GRA_CH                         

#endif         // #ifndef _GRA_CH

// * EOF *
