//////////////////////////////////////////////////////////////////////
//
//  MEMOEDIT.CH
//
//  Copyright:
//      Alaska Software, (c) 1998-2023. All rights reserved.         
//  
//  Contents:
//      #define constants for the MemoEdit() user function or
//      the user defined code block
//   
//////////////////////////////////////////////////////////////////////


// Memoedit.ch is not included
#ifndef  _MEMOEDIT_CH         

*******************************************************************************
* Defines for MemoEdit() mode when calling the user function or code block
*******************************************************************************

// Wait for next key
#define  ME_IDLE           0  
// Last key was not processed by MemoEdit() Text buffer was not changed yet
#define  ME_UNKEY          1  
// Last key was not processed by MemoEdit(), Text buffer was changed
#define  ME_UNKEYX         2  
// Initialization mode
#define  ME_INIT           3  
// Memoedit requests an input from the user function, e.g. after ME_PASTE
#define  ME_REQUEST        4  

*******************************************************************************
* Return value of user function or code block
*******************************************************************************

// Execute default action
#define  ME_DEFAULT        0  
// Ignore unknown key
#define  ME_IGNORE        32  
// Treat unknown key as character
#define  ME_DATA          33  
// Toggle word wrapping mode
#define  ME_TOGGLEWRAP    34  
// Toggle scroll mode
#define  ME_TOGGLESCROLL  35  
// Go to next word to the right
#define  ME_WORDRIGHT    100  
// Go to last character in edit window
#define  ME_BOTTOMRIGHT  101  
// Paste text string into text buffer at current cursor position
#define  ME_PASTE        110  


// Memoedit.ch is included
#define  _MEMOEDIT_CH         


#endif  // #ifndef _MEMOEDIT_CH

// * EOF *
