//////////////////////////////////////////////////////////////////////
//
//  NATMSG.CH
//
//  Copyright:
//      Alaska Software, (c) 1996-2023. All rights reserved.         
//  
//  Contents:
//      Define constants for the function NationMsg()
//   
//////////////////////////////////////////////////////////////////////



#ifndef _NATMSG_CH 
// Natmsg.ch is not included

#define NAT_MSG_DATABASE         1
#define NAT_MSG_EXAMPLES         2
#define NAT_MSG_PAGE             3
#define NAT_MSG_SUBTOTAL         4
#define NAT_MSG_SUBSUBTOTAL      5
#define NAT_MSG_TOTAL            6
#define NAT_MSG_INSERT_ON        7

// = SPACE ( strlen (NAT_MSG_INSERT) )
#define NAT_MSG_INSERT_OFF       8      

#define NAT_MSG_INVALID_DATE     9
#define NAT_MSG_RANGE_LOW        10
#define NAT_MSG_RANGE_HIGH       11
#define NAT_MSG_YESNO            12
#define NAT_MSG_OK               13
#define NAT_MSG_DEFAULT_WAIT     14
#define NAT_MSG_DBRECORD         15
#define NAT_MSG_DBEMPTY          16
#define NAT_MSG_DBAPPEND         17
#define NAT_MSG_DBDELETED        18
#define NAT_MSG_DBBOF            19

#define NAT_MSG_ABORT            20
#define NAT_MSG_ABORT_EDIT       21

#define NAT_MSG_LOCKFAILURE      22

// "Xbase++ Font Dialog"
#define NAT_MSG_FONT_DIALOG      23 

// "The quick brown fox jumps over the lazy dog"
#define NAT_MSG_FONT_SAMPLE      24 

// "Help"
#define NAT_MSG_HELP_TITLE       25 

#define NAT_MSG_CHAR_NO          30
#define NAT_MSG_CHAR_YES         31
#define NAT_MSG_CHAR_FALSE       32
#define NAT_MSG_CHAR_TRUE        33
#define NAT_MSG_STRING_NO        34
#define NAT_MSG_STRING_YES       35
#define NAT_MSG_STRING_FALSE     36 
#define NAT_MSG_STRING_TRUE      37
#define NAT_MSG_STRING_WRONG     38
#define NAT_MSG_STRING_CORRECT   39

#define NAT_MSG_MONDAY           50  
#define NAT_MSG_TUESDAY          51  
#define NAT_MSG_WEDNESDAY        52  
#define NAT_MSG_THURSDAY         53  
#define NAT_MSG_FRIDAY           54  
#define NAT_MSG_SATURDAY         55  
#define NAT_MSG_SUNDAY           56  

#define NAT_MSG_MONTH_1          57
#define NAT_MSG_MONTH_2          58
#define NAT_MSG_MONTH_3          59
#define NAT_MSG_MONTH_4          60
#define NAT_MSG_MONTH_5          61
#define NAT_MSG_MONTH_6          62
#define NAT_MSG_MONTH_7          63
#define NAT_MSG_MONTH_8          64
#define NAT_MSG_MONTH_9          65
#define NAT_MSG_MONTH_10         66
#define NAT_MSG_MONTH_11         67
#define NAT_MSG_MONTH_12         68


// Button Strings
#define  NAT_MSG_B_OK            70
#define  NAT_MSG_B_CANCEL        71
#define  NAT_MSG_B_HELP          72
#define  NAT_MSG_B_NEXT          73
#define  NAT_MSG_B_PREVIOUS      74
#define  NAT_MSG_B_GOTOP         75
#define  NAT_MSG_B_GOBOTTOM      76
#define  NAT_MSG_B_EDIT          77
#define  NAT_MSG_B_SAVE          78
#define  NAT_MSG_B_UNDO          79
#define  NAT_MSG_B_INSERT        80
#define  NAT_MSG_B_DELETE        81
#define  NAT_MSG_B_RECALL        82
#define  NAT_MSG_B_SEEK          83
#define  NAT_MSG_B_PRINT         84
#define  NAT_MSG_B_OPEN          85
#define  NAT_MSG_B_CLOSE         86
#define  NAT_MSG_B_RETRY         87


// Button Help Strings
#define  NAT_MSG_BH_OK           90
#define  NAT_MSG_BH_CANCEL       91
#define  NAT_MSG_BH_HELP         92
#define  NAT_MSG_BH_NEXT         93
#define  NAT_MSG_BH_PREVIOUS     94
#define  NAT_MSG_BH_GOTOP        95
#define  NAT_MSG_BH_GOBOTTOM     96
#define  NAT_MSG_BH_EDIT         97
#define  NAT_MSG_BH_SAVE         98
#define  NAT_MSG_BH_UNDO         99
#define  NAT_MSG_BH_INSERT      100
#define  NAT_MSG_BH_DELETE      101
#define  NAT_MSG_BH_RECALL      102
#define  NAT_MSG_BH_SEEK        103
#define  NAT_MSG_BH_PRINT       104
#define  NAT_MSG_BH_OPEN        105
#define  NAT_MSG_BH_CLOSE       106
#define  NAT_MSG_BH_RETRY       107


/*
   constants for platform independent
   font selection
*/

// Font Styles
#define  NAT_MSG_FNT_STYLE_BOLD      108
#define  NAT_MSG_FNT_STYLE_ITALIC    109

// Font Names
#define  NAT_MSG_FNT_FIXED_SMALL     110
#define  NAT_MSG_FNT_FIXED_MEDIUM    111
#define  NAT_MSG_FNT_FIXED_LARGE     112
#define  NAT_MSG_FNT_FIXED_XLARGE    113

#define  NAT_MSG_FNT_PROP_SMALL      114
#define  NAT_MSG_FNT_PROP_MEDIUM     115
#define  NAT_MSG_FNT_PROP_LARGE      116
#define  NAT_MSG_FNT_PROP_XLARGE     117

#define  NAT_MSG_FNT_HELV_SMALL      118
#define  NAT_MSG_FNT_HELV_MEDIUM     119
#define  NAT_MSG_FNT_HELV_LARGE      120
#define  NAT_MSG_FNT_HELV_XLARGE     121

#define  NAT_MSG_FNT_COURIER_SMALL   122
#define  NAT_MSG_FNT_COURIER_MEDIUM  123
#define  NAT_MSG_FNT_COURIER_LARGE   124
#define  NAT_MSG_FNT_COURIER_XLARGE  125

#define  NAT_MSG_FNT_TIMES_SMALL     126
#define  NAT_MSG_FNT_TIMES_MEDIUM    127
#define  NAT_MSG_FNT_TIMES_LARGE     128
#define  NAT_MSG_FNT_TIMES_XLARGE    129

// Box characters
#define NAT_MSG_B_SINGLE             200
#define NAT_MSG_B_DOUBLE             201
#define NAT_MSG_B_SINGLE_DOUBLE      202
#define NAT_MSG_B_DOUBLE_SINGLE      203
#define NAT_MSG_B_THIN               204
#define NAT_MSG_B_FAT                205
#define NAT_MSG_B_CONNECT_LEFT       206
#define NAT_MSG_B_CONNECT_RIGHT      207
#define NAT_MSG_B_CONNECT_MID        208
#define NAT_MSG_B_HEAD               209

// GC message
#define NAT_MSG_GCNAME               221
#define NAT_MSG_GCMSG                222 
#define NAT_MSG_DBGVARHIDDEN         223
#define NAT_MSG_DBGVARNOVALUE        224

// Natmsg.ch is included
#define _NATMSG_CH               

#endif

// EOF
