//////////////////////////////////////////////////////////////////////
//
//  OS.CH
//
//  Copyright:
//       Alaska Software, (c) 2001-2023. All rights reserved.         
//  
//  Contents:
//       Constants used for calling functions that return
//       information about the operating system
//   
//////////////////////////////////////////////////////////////////////


#ifndef  _OS_CH

// constants for OS()
#define  OS_DESCRIPTION           0
#define  OS_PLATFORM              1
#define  OS_FAMILY                2
#define  OS_PRODUCT               3
#define  OS_FULLNAME              4
#define  OS_VERSION               5
#define  OS_PATCH                 6
#define  OS_BUILD                 7

// constants for Memory()
#define MEM_VIRT_AVAIL        0
#define MEM_VIRT_TOTAL        2
#define MEM_RAM_AVAIL         3
#define MEM_RAM_TOTAL         4
#define MEM_PROC_TOTAL         MEM_VIRT_TOTAL+100
#define MEM_PROC_AVAIL         MEM_VIRT_AVAIL+100
#define MEM_HANDLES_AVAIL     6
#define MEM_HANDLES_TOTAL     7
#define MEM_HANDLES_USED      5


// constants for WriteCToLog()
#define LOG_SUCCESS                0
#define LOG_ERROR_TYPE             1
#define LOG_WARNING_TYPE           2
#define LOG_INFORMATION_TYPE       4
#define LOG_AUDIT_SUCCESS          8
#define LOG_AUDIT_FAILURE          16

#define _OS_CH
#endif 


