//////////////////////////////////////////////////////////////////////
//
//  PROMPT.CH
//
//  Copyright:
//      Alaska Software, (c) 1998-2023. All rights reserved.         
//  
//  Contents:
//      #command directives for the text mode menu system
//   
//////////////////////////////////////////////////////////////////////


// Prompt.ch is not included
#ifndef  _PROMPT_CH          

*******************************************************************************
* Commands: @...PROMPT...MESSAGE, MENU TO
*******************************************************************************

#command  @ <nRow>, <nCol> PROMPT <prompt> [MESSAGE <message>] ;
      =>  _AtPrompt(<nRow>, <nCol>, <prompt>, promptList, <message>)

#command  MENU TO <var> ;
      =>  <var> := _MenuTo(PromptList, <var>, UPPER(#<var>))

*******************************************************************************
* Commands: SET WRAP, SET MESSAGE
*******************************************************************************

#command  SET WRAP <logic:ON,OFF,&> ;
      =>  SET( _SET_WRAP, <(logic)> )

#command  SET WRAP (<logic>) ;
      =>  SET( _SET_WRAP, <logic> )

#command  SET MESSAGE TO <nRow> [<center: CENTER, CENTRE>] ;
      =>  SET( _SET_MESSAGE, <nRow> ) ;;
          SET( _SET_MCENTER, <.center.> )

#command  SET MESSAGE TO ;
      =>  SET( _SET_MESSAGE, 0 ) ;;
          SET( _SET_MCENTER, .F. )



// Prompt.ch is included
#define  _PROMPT_CH          

#endif          // #ifndef _PROMPT_CH

// * EOF *
