//////////////////////////////////////////////////////////////////////
//
//  SET.CH
//
//  Copyright:
//      Alaska Software, (c) 1996-2023. All rights reserved.         
//  
//  Contents:
//      #define constants for the function Set()
//   
//  Remarks:
//       When calling the function Set() always define constants from SET.CH
//       should be used. The values of the constants may vary in future
//       versions of Xbase++.
//   
//////////////////////////////////////////////////////////////////////


#include "natmsg.ch"

#ifndef  _SET_CH                       
// Set.ch is not included

#define  _SET_EXACT        1  // SETs for comparisons
#define  _SET_LEXICAL     39
#define  _SET_COLLATION   41
#define  _SET_FIXED        2  // SETs for number format
#define  _SET_DECIMALS     3  
#define  _SET_CENTURY     40  // SETs for date format
#define  _SET_DATEFORMAT   4
#define  _SET_EPOCH        5
#define  _SET_TIME        42

#define  _SET_PATH         6  // SETs for directories
#define  _SET_DEFAULT      7

#define  _SET_EXCLUSIVE    8  // SETs for database engine
#define  _SET_SOFTSEEK     9
#define  _SET_UNIQUE      10
#define  _SET_DELETED     11

#define  _SET_CANCEL      12  // SETs for the keyboard
#define  _SET_TYPEAHEAD   14

#define  _SET_COLOR       15  // SETs for screen output
#define  _SET_CURSOR      16
#define  _SET_CONSOLE     17

#define  _SET_ALTERNATE   18  // SETs for print output
#define  _SET_ALTFILE     19
#define  _SET_DEVICE      20
#define  _SET_EXTRA       21
#define  _SET_EXTRAFILE   22
#define  _SET_PRINTER     23
#define  _SET_PRINTFILE   24
#define  _SET_MARGIN      25

#define  _SET_BELL        26  // SETs for the Get system
#define  _SET_CONFIRM     27
#define  _SET_ESCAPE      28
#define  _SET_INSERT      29
#define  _SET_EXIT        30
#define  _SET_INTENSITY   31
#define  _SET_SCOREBOARD  32
#define  _SET_DELIMITERS  33
#define  _SET_DELIMCHARS  34

#define  _SET_WRAP        35  // SETs for the menu system
#define  _SET_MESSAGE     36
#define  _SET_MCENTER     37

#define  _SET_CHARSET     43 

#define  _SET_HANDLEEVENT 44

#define  _SET_DEVTIMEOUT  45  // SETs for device output

#define  _SET_ACCELERATORS 46 // Reserved for future use

#define  _SET_COLORMODE   47  // SETs for color management

#define  _SET_OPTIMIZE    48  // SETs for expression optimizer

#define  _SET_RUSHMORE    49  // SETs for rushmore optimizer

#define  _SET_SMARTFILTER 50  // SETs for smart filtering

#define  _SET_NULLVALUE   51  // SETs for NULL value support

#define  _SET_HASH        52  // SETs for hash algorithms

#define  _SET_COUNT       52  // Total number of SET constants

// Set.ch is included
#define  _SET_CH                       

#endif  // #ifndef _SET_CH

// * EOF *

