//////////////////////////////////////////////////////////////////////
//
//  SIMPLEIO.CH
//
//  Copyright:
//      Alaska Software, (c) 1998-2023. All rights reserved.         
//  
//  Contents:
//      #commands directives for standard input/output using standard I/O 
//      functions. Redefine the commands ?, ??, ACCEPT and ACCEPT TO
//      to use standard I/O
//   
//////////////////////////////////////////////////////////////////////


// Simpleio.ch is not included
#ifndef  _SIMPLEIO_CH        

#include  "fileio.ch"

#command  ? [<xList,...>] ;
      =>  ( OutStd(Chr(13)+Chr(10)) [, OutStd(<xList>)] )

#command  ?? [<xList,...>] ;
      =>  OutStd(<xList>)

#command  ACCEPT TO <Var> ;
      =>  <Var> := StrTran( FReadStr(FH_STDIN, 256), Chr(13)+Chr(10) )

#command  ACCEPT <cPrompt> TO <Var> ;
      =>  ? <cPrompt> ;;
          ACCEPT TO <Var>


// Simpleio.ch is included
#define  _SIMPLEIO_CH        

#endif     // #ifndef _SIMPLEIO_CH

// * EOF *
