//////////////////////////////////////////////////////////////////////
//
//  SQL.CH
//
//  Copyright:
//     Alaska Software, (c) 2010-2023. All rights reserved.         
//  
//  Contents:
//     SQL constants for Universal SQL
//   
//////////////////////////////////////////////////////////////////////



// Prevent duplicate include
#ifndef _SQL_CH
#define _SQL_CH

/*
 * USQL data sources
 */
#define USQL_SOURCE_DEFAULT    1
#define USQL_SOURCE_VALUES     2
#define USQL_SOURCE_ARRAY      3
#define USQL_SOURCE_OBJECT     4
#define USQL_SOURCE_MEMVAR     5  
#define USQL_SOURCE_STATEMENT  6

/*
 * USQL query result handler
 */
#define USQL_RESULT_WORKAREA     1
#define USQL_RESULT_ARRAY        2
#define USQL_RESULT_OBJECTS      4
#define USQL_RESULT_EVAL         8
#define USQL_RESULT_SINGLE_VALUE 16
#define USQL_RESULT_TABLE        32

/*
 * USQL join types
 */
#define USQL_JOIN_INNER          1
#define USQL_JOIN_LEFT           2
#define USQL_JOIN_RIGHT          4
#define USQL_JOIN_FULL           8
#define USQL_JOIN_LEFT_OUTER    16
#define USQL_JOIN_RIGHT_OUTER   32
#define USQL_JOIN_FULL_OUTER    64

/*
 * USQL order direction
 */
#define USQL_ASCEND  1
#define USQL_DESCEND 2

/*
 * USQL helpers
 */
#define USQL_ALL        1
#define USQL_DISTINCT   2
#define USQL_UNION      4
#define USQL_INTERSECT  8
#define USQL_EXCEPT    16

#endif
