//////////////////////////////////////////////////////////////////////
//
//  STRUCT.CH
//
//  Copyright:
//     Alaska Software, (c) 2002-2023. All rights reserved.         
//  
//  Contents:
//     #define constants and commands allow definition
//     of low-level data structures
//   
//////////////////////////////////////////////////////////////////////


#ifndef _STRUCT_HEADER_DAEMON
#define _STRUCT_HEADER_DAEMON

// Usage

#ifdef __XPP__

#define STRUCT_STRUCTURE 1
#define STRUCT_UNION     2

#command LOCAL <variablename> AS STRUCTURE <structurename> => LOCAL <variablename> := <structurename>_xpp_structure():new()

#command _DEFINESTRUCTUREUNION <structype:STRUCTURE,UNION> <name> [PACK <packsize>] =>       ;
         FUNCTION <name>()                                                                   ;;
            LOCAL oSuperClass                                                                ;;
            STATIC oClassObject := NIL                                                       ;;
            IF NIL == oClassObject                                                           ;;
               oSuperClass  := ClassObject( "__Abstract_" + #<name> )                        ;;
               oClassObject := oSuperClass:CreateStructureClass( #<name> )                   ;;
            ENDIF                                                                            ;;
         RETURN oClassObject                                                                 ;;
         CLASS __Abstract_<name> FROM __Abstract_Structure                                   ;;
            EXPORTED:                                                                        ;;
               INLINE CLASS METHOD initClass()                                               ;;
                  LOCAL aStruct := {}                                                        ;;
                  LOCAL nStructType := __Struct(<structype>)                                 ;;
                  LOCAL nPackSize   := NIL                                                   ;;
                  [nPackSize := <packsize>]
#command VAR <varname> AS [<ptr: @>]<type>                      => AAdd(aStruct, { #<varname>, __Sys( <type> ), <.ptr.>, NIL } )
#command VAR <varname> AS [<ptr: @>]<type>\[<arraylen>\]        => AAdd(aStruct, { #<varname>, __Sys( <type> ), <.ptr.>, <arraylen> } )

#command VAR <x> AS [<ptr: @>] STRUCTURE <type>                 => AAdd(aStruct, { #<x>, &(#<type>+"_xpp_structure")(), <.ptr.>, NIL } )
#command VAR <x> AS [<ptr: @>] STRUCTURE <type>\[<arraylen>\]   => AAdd(aStruct, { #<x>, &(#<type>+"_xpp_structure")(), <.ptr.>, <arraylen> } )

#command VAR <x> AS [<ptr: @>] UNION     <type>                 => AAdd(aStruct, { #<x>, &(#<type>+"_xpp_structure")(), <.ptr.>, NIL } )
#command VAR <x> AS [<ptr: @>] UNION     <type>\[<arraylen>\]   => AAdd(aStruct, { #<x>, &(#<type>+"_xpp_structure")(), <.ptr.>, <arraylen> } )

#command _ENDSTRUCTUREUNION => ::setup(nStructType, aStruct, nPackSize)                      ;;
               RETURN self                                                                   ;;
         ENDCLASS

#command STRUCTURE <name> [PACK <packsize>]  => _DEFINESTRUCTUREUNION STRUCTURE <name>_xpp_structure [PACK <packsize>]
#command UNION     <name> [PACK <packsize>]  => _DEFINESTRUCTUREUNION UNION     <name>_xpp_structure [PACK <packsize>]
#command ENDSTRUCTURE   => _ENDSTRUCTUREUNION
#command ENDUNION       => _ENDSTRUCTUREUNION

#xtrans __Struct(STRUCTURE) => STRUCT_STRUCTURE
#xtrans __Struct(UNION)     => STRUCT_UNION

#endif // __XPP__

#endif // _STRUCT_HEADER_DAEMON
