//////////////////////////////////////////////////////////////////////
//
//  THREAD.CH
//
//  Copyright:
//      Alaska Software, (c) 1998-2023. All rights reserved.         
//  
//  Contents:
//      Constants for the Thread class
//   
//////////////////////////////////////////////////////////////////////


#ifndef  _THREAD_CH

// constants for Thread:setPriority()
#define PRIORITY_IDLE            -15
#define PRIORITY_LOWEST           -2
#define PRIORITY_BELOWNORMAL      -1
#define PRIORITY_NORMAL            0
#define PRIORITY_ABOVENORMAL       1
#define PRIORITY_HIGHEST           2
#define PRIORITY_TIME_CRITICAL    15

// constants for Thread():quit()
// quit thread completely and set :interval to NIL
#define QUIT_NORESTART             0  
// quit thread but do not change :interval 
#define QUIT_RESTART               1  

// maximum number of threads for ThreadWait...()
#define THREAD_WAIT_MAX           64

// constants for ThreadInfo()
#define THREADINFO_TID          1
#define THREADINFO_SYSTHND      2
#define THREADINFO_FUNCINFO     4
#define THREADINFO_TOBJ         8

#define _THREAD_CH
            
#endif    // #ifndef  _THREAD_CH
