//////////////////////////////////////////////////////////////////////
//
//  WINSDK-WINUSER.CH
//
//  Copyright:
//      Alaska Software, (c) 1997-2023. All rights reserved.         
//  
//  Contents:
//       Frequently used #define constants from the WinSDK header winuser.h
//   
//////////////////////////////////////////////////////////////////////



// winsdk-winuser.ch is not included
#ifndef __WINSDK_WINUSER_CH__

// Window Messages
#define WM_QUIT                                 0x0012
#define WM_DRAWITEM                             0x002B
#define WM_NCLBUTTONDOWN                        0x00A1
#define WM_KEYFIRST                             0x0100
#define WM_KEYDOWN                              0x0100
#define WM_KEYUP                                0x0101
#define WM_CHAR                                 0x0102
#define WM_DEADCHAR                             0x0103
#define WM_SYSKEYDOWN                           0x0104
#define WM_SYSKEYUP                             0x0105
#define WM_SYSCHAR                              0x0106
#define WM_SYSDEADCHAR                          0x0107
#define WM_KEYLAST                              0x0108
#define WM_SYSCOMMAND                           0x0112
#define WM_QUERYUISTATE                         0x0129
#define WM_MDIGETACTIVE                         0x0229
#define WM_CUT                                  0x0300
#define WM_COPY                                 0x0301
#define WM_PASTE                                0x0302
#define WM_CLEAR                                0x0303
#define WM_UNDO                                 0x0304
#define WM_THEMECHANGED                         0x031A

// Edit Control Messages
#define EM_LINEINDEX                            0x00BB
#define EM_POSFROMCHAR                          0x0426

// Combo Box messages
#define CB_FINDSTRING                          0x014C
#define LB_FINDSTRING                          0x018F
#define CB_SHOWDROPDOWN                        0x014F
#define CB_GETDROPPEDSTATE                     0x0157

// System Menu Command Values
#define SC_SIZE                                 0xF100
#define SC_KEYMENU                              0xF100
#define SC_MINIMIZE                             0xF020
#define SC_MAXIMIZE                             0xF030
#define SC_NEXTWINDOW                           0xF040
#define SC_PREVWINDOW                           0xF050

// WM_NCHITTEST and MOUSEHOOKSTRUCT Mouse Position Codes
#define HTBOTTOMRIGHT                           17

// Virtual Keys, Standard Set
#define VK_TAB                                  0x09
#define VK_SHIFT                                0x10
#define VK_CONTROL                              0x11
#define VK_MENU                                 0x12
#define VK_ESCAPE                               0x1B
#define VK_SPACE                                0x20
#define VK_LWIN                                 0x5B
#define VK_RWIN                                 0x5C
#define VK_F6                                   0x75
#define VK_F4                                   0x73
#define VK_MINUS                                0xBD

// Window field offsets for GetWindowLong()
#define GWL_HWNDPARENT                          -8
#define GWL_STYLE                               -16
#define GWL_EXSTYLE                             -20

// Window Styles
#define WS_BORDER                               0x00800000

// Extended Window Styles
#define WS_EX_TRANSPARENT                       0x00000020
#define WS_EX_CLIENTEDGE                        0x00000200

// Icon/Cursor
#define IMAGE_ICON                              1
#define LR_DEFAULTCOLOR                         0x0000
#define LR_LOADFROMFILE                         0x0010

#define DI_MASK                                 0x0001
#define DI_IMAGE                                0x0002
#define DI_NORMAL                               0x0003
#define DI_COMPAT                               0x0004
#define DI_DEFAULTSIZE                          0x0008

// Monolithic state-drawing routine
#define DST_ICON                                0x0003
#define DSS_DISABLED                            0x0020

// SetWindowsHook() codes
#define WH_KEYBOARD_LL                          13

// ShowWindow() Commands
#define SW_SHOWNORMAL                           1

// SetWindowPos Flags
#define SWP_FRAMECHANGED                        0x0020
#define SWP_NOSIZE                              0x0001
#define SWP_NOMOVE                              0x0002
#define SWP_NOZORDER                            0x0004

// DrawText() Format Flags
#define DT_SINGLELINE                           0x20
#define DT_EXPANDTABS                           0x40
#define DT_LEFT                                 0x00
#define DT_VCENTER                              0x04
#define DT_WORDBREAK                            0x10
#define DT_TABSTOP                              0x80
#define DT_HIDEPREFIX                           0x100000

// flags for DrawFrameControl
#define DFC_SCROLL                              3
#define DFCS_SCROLLSIZEGRIP                     8

// Hook codes
#define HC_ACTION                               0

// GetSystemMetrics() codes
#define SM_CXVSCROLL                            2
#define SM_CYHSCROLL                            3
#define SM_CYVSCROLL                            20
#define SM_CXMENUCHECK                          71
#define SM_XVIRTUALSCREEN                       76
#define SM_YVIRTUALSCREEN                       77
#define SM_CXVIRTUALSCREEN                      78
#define SM_CYVIRTUALSCREEN                      79
#define SM_CMONITORS                            80
#define SM_DIGITIZER                            94
#define SM_MAXIMUMTOUCHES                       95

// GetSystemMetrics(SM_DIGITIZER) flag values
#define NID_INTEGRATED_TOUCH                    0x01
#define NID_EXTERNAL_TOUCH                      0x02
#define NID_INTEGRATED_PEN                      0x04
#define NID_EXTERNAL_PEN                        0x08
#define NID_READY                               0x80

// Parameter for SystemParametersInfo
#define SPI_GETWHEELSCROLLLINES                 104

// Multimonitor API
#define CCHDEVICENAME                           32

#define MONITORINFOF_PRIMARY                    1

#define MONITOR_DEFAULTTONEAREST                2

// Raw Input Device Information
#define RIDI_DEVICENAME                         0x20000007

// Type of the raw input
#define RIM_TYPEHID                             2

// Flags for EnumDisplayDevices
#define EDD_GET_DEVICE_INTERFACE_NAME 0x00000001

// winsdk-winuser.ch is included
#define __WINSDK_WINUSER_CH__

#endif // __WINSDK_WINUSER_CH__
// EOF
