//////////////////////////////////////////////////////////////////////
//
//  XB2.CH
//
//  Copyright:
//      Alaska Software, (c) 1998-2023. All rights reserved.         
//  
//  Contents:
//      Translation of the old Xbase/2 names into the new 
//      operating system independent Xbase++ names.
//   
//////////////////////////////////////////////////////////////////////


#ifndef _XB2_CH
#define _XB2_CH

// type constants (see types.ch) 
#define XB2_UNDEF       XPP_UNDEF 
#define XB2_CHARACTER   XPP_CHARACTER    
#define XB2_NUMERIC     XPP_NUMERIC 
#define XB2_LOGICAL     XPP_LOGICAL 
#define XB2_DATE        XPP_DATE 
#define XB2_ARRAY       XPP_ARRAY 
#define XB2_BLOCK       XPP_BLOCK        
#define XB2_OBJECT      XPP_OBJECT 
#define XB2_REFERENCE   XPP_REFERENCE 
#define XB2_MEMO        XPP_MEMO 
#define XB2_DOUBLE      XPP_DOUBLE       
#define XB2_ILLEGAL     XPP_ILLEGAL      

// #defines for oError:severity (see error.ch)
#define  XB2_ES_WHOCARES        XPP_ES_WHOCARES
#define  XB2_ES_WARNING         XPP_ES_WARNING 
#define  XB2_ES_ERROR           XPP_ES_ERROR   
#define  XB2_ES_FATAL           XPP_ES_FATAL

// #defines for oError:genCode  (see error.ch)
#define  XB2_ERR_ARG_VALUE      XPP_ERR_ARG_VALUE
#define  XB2_ERR_ARG_TYPE       XPP_ERR_ARG_TYPE
#define  XB2_ERR_ARRAY_BOUNDS   XPP_ERR_ARRAY_BOUNDS
#define  XB2_ERR_ARG_COUNT      XPP_ERR_ARG_COUNT
#define  XB2_ERR_NUMOVERFLOW    XPP_ERR_NUMOVERFLOW 
#define  XB2_ERR_ZERODIV        XPP_ERR_ZERODIV 
#define  XB2_ERR_NUMERR         XPP_ERR_NUMERR 
#define  XB2_ERR_MEMORY_FULL    XPP_ERR_MEMORY_FULL 
#define  XB2_ERR_STACK_OVERFLOW XPP_ERR_STACK_OVERFLOW 
#define  XB2_ERR_SYNTAX         XPP_ERR_SYNTAX 
#define  XB2_ERR_NOFUNC         XPP_ERR_NOFUNC 
#define  XB2_ERR_NOVAR          XPP_ERR_NOVAR 
#define  XB2_ERR_NOMETHOD       XPP_ERR_NOMETHOD 
#define  XB2_ERR_METHOD_DEF     XPP_ERR_METHOD_DEF 
#define  XB2_ERR_METHOD_ACCESS  XPP_ERR_METHOD_ACCESS 
#define  XB2_ERR_NOMEMBERVAR    XPP_ERR_NOMEMBERVAR 
#define  XB2_ERR_VAR_DEF        XPP_ERR_VAR_DEF 
#define  XB2_ERR_MEMBERVAR_ACCESS XPP_ERR_MEMBERVAR_ACCESS 
#define  XB2_ERR_MEMBERVAR_TYPE XPP_ERR_MEMBERVAR_TYPE 
#define  XB2_ERR_INSTANCE_METHOD XPP_ERR_INSTANCE_METHOD 
#define  XB2_ERR_INSTANCE_VAR   XPP_ERR_INSTANCE_VAR 
#define  XB2_ERR_DOS            XPP_ERR_DOS 
#define  XB2_ERR_CORRUPTION     XPP_ERR_CORRUPTION 
#define  XB2_ERR_LOAD_VERSION   XPP_ERR_LOAD_VERSION
#define  XB2_ERR_DMLB_INIT      XPP_ERR_DMLB_INIT 
#define  XB2_ERR_DMLB_FRAMEWORK XPP_ERR_DMLB_FRAMEWORK 
#define  XB2_ERR_DBE_DLLNAME    XPP_ERR_DBE_DLLNAME 
#define  XB2_ERR_DBE_BUILDNAMEUSED XPP_ERR_DBE_BUILDNAMEUSED 
#define  XB2_ERR_DBE_BUILD      XPP_ERR_DBE_BUILD 
#define  XB2_ERR_DBE_COMPONENT  XPP_ERR_DBE_COMPONENT 
#define  XB2_ERR_DBE_INIT       XPP_ERR_DBE_INIT 
#define  XB2_ERR_DBE_UNINIT     XPP_ERR_DBE_UNINIT 
#define  XB2_ERR_DBE_UNSUPPORTED XPP_ERR_DBE_UNSUPPORTED 
#define  XB2_ERR_DBE_INTERN     XPP_ERR_DBE_INTERN 
#define  XB2_ERR_DBE_NODEFAULT  XPP_ERR_DBE_NODEFAULT 
#define  XB2_ERR_NODBE          XPP_ERR_NODBE 
#define  XB2_ERR_DATATYPE       XPP_ERR_DATATYPE 
#define  XB2_ERR_DATAWIDTH      XPP_ERR_DATAWIDTH 
#define  XB2_ERR_KEYWIDTH       XPP_ERR_KEYWIDTH 
#define  XB2_ERR_NOFIELD        XPP_ERR_NOFIELD 
#define  XB2_ERR_NOALIAS        XPP_ERR_NOALIAS 
#define  XB2_ERR_DUPNAME        XPP_ERR_DUPNAME 
#define  XB2_ERR_NOTABLE        XPP_ERR_NOTABLE 
#define  XB2_ERR_NOORDER        XPP_ERR_NOORDER 
#define  XB2_ERR_CREATE         XPP_ERR_CREATE 
#define  XB2_ERR_OPEN           XPP_ERR_OPEN 
#define  XB2_ERR_CLOSE          XPP_ERR_CLOSE 
#define  XB2_ERR_READ           XPP_ERR_READ 
#define  XB2_ERR_WRITE          XPP_ERR_WRITE 
#define  XB2_ERR_EXCL_REQUIRED  XPP_ERR_EXCL_REQUIRED 
#define  XB2_ERR_LOCK_REQUIRED  XPP_ERR_LOCK_REQUIRED 
#define  XB2_ERR_READONLY       XPP_ERR_READONLY 
#define  XB2_ERR_AUTOLOCK       XPP_ERR_APPENDLOCK
#define  XB2_ERR_LOCK           XPP_ERR_LOCK 
#define  XB2_ERR_LOSTUPDATES    XPP_ERR_LOSTUPDATES 
#define  XB2_ERR_THREAD_ID      XPP_ERR_THREAD_ID 
#define  XB2_ERR_PRINT          XPP_ERR_PRINT 
#define  XB2_ERR_METHOD_NOT_OVERLOADED  XPP_ERR_METHOD_NOT_OVERLOADED 
#define  XB2_ERR_OBJECT_ACCESS  XPP_ERR_OBJECT_ACCESS 
#define  XB2_ERR_OBJECT_STATE   XPP_ERR_OBJECT_STATE 
#define  XB2_ERR_OBJECT_CREATION XPP_ERR_OBJECT_CREATION 
#define  XB2_ERR_ILLEGAL_MATRIX XPP_ERR_ILLEGAL_MATRIX 
#define  XB2_ERR_BREAK          XPP_ERR_BREAK 
#define  XB2_ERR_CONTYPE        XPP_ERR_CONTYPE 
#define  XB2_ERR_READLOCKED     XPP_ERR_READLOCKED 
#define  XB2_ERR_WRITELOCKED    XPP_ERR_WRITELOCKED 
#define  XB2_ERR_LOCKLIMIT      XPP_ERR_LOCKLIMIT 
#define  XB2_ERR_NOTLOCKED      XPP_ERR_NOTLOCKED 
#define  XB2_ERR_INVALID_HANDLE XPP_ERR_INVALID_HANDLE 

// C-API
#ifdef __WATCOMC__
#pragma aux _xbase_2 "*" \
        parm caller [EAX EDX ECX] frame
#endif
#define XB2ENTRY        XPPENTRY  
#define XB2APIENTRY     XPPAPIENTRY 
#define XB2RET          XPPRET
#define XB2APIRET       XPPAPIRET

#endif   // _XB2_CH                  
