//////////////////////////////////////////////////////////////////////
//
//  XBTDISK.CH
//
//  Copyright:
//      Alaska Software, (c) 1996-2023. All rights reserved.         
//  
//  Contents:
//      #define constants for the disk-functions of XbTools-III
//   
//////////////////////////////////////////////////////////////////////


#ifndef _XBTDISK_CH
#define _XBTDISK_CH

//*****************************************************************************
// file attributes for setFCreate(), fileAttr(), setFAttr() and fileSeek()
//*****************************************************************************
#define FA_NORMAL                 0
#define FA_READONLY               1
#define FA_HIDDEN                 2
#define FA_SYSTEM                 4
#define FA_VOLUME                 8
#define FA_DIRECTORY             16   
#define FA_ARCHIVE               32
#define FA_ENCRYPTED             64
#define FA_TEMPORARY            256
#define FA_SPARSE_FILE          512
#define FA_REPARSE_POINT       1024
#define FA_COMPRESSED          2048
#define FA_OFFLINE             4096
#define FA_NOT_CONTENT_INDEXED 8192

//*****************************************************************************
// share modes for setShare()
//*****************************************************************************
#define SHARE_COMPAT              0
#define SHARE_EXCLUSIVE           1
#define SHARE_DENYWRITE           2
#define SHARE_DENYREAD            3
#define SHARE_DENYNONE            4

//*****************************************************************************
// result-values of diskType()
//*****************************************************************************

#define DT_NO_DISK                0   // no drive found
#define DT_DS_SEC_8             255   // double sided 8 sectors
#define DT_SS_SEC_8             254   // single sided 8 sectors
#define DT_DS_SEC_9             253   // double sided 9 sectors
#define DT_SS_SEC_9             252   // single sided 9 sectors
#define DT_DS_SEC_15            249   // double sided 15 Sektoren (HD-Disk)
#define DT_35_SEC_9             249   // double sided 3,5" 9 sectors (= 5,25 HD)
#define DT_35_SEC_18            240   // double sided 3,5" 18 sectors
#define DT_HARDDISK             248   // hard disk
#define DT_CDROM                244   // CD-ROM

//*****************************************************************************
// result values of driveType()
//*****************************************************************************

#define RAMDISK                   0   // ram-disk or no drive found
#define FLOPPY_ND                 1   // floppy (no media change check)
#define FLOPPY                    2   // floppy (media change check)
#define HARDDISK                  3   // hard disk
#define CDROM                     4   // CD-ROM

//*****************************************************************************
// result values of floppyType()
//*****************************************************************************

#define FLOPPY_NONE               0   // No floppy drive
#define FLOPPY_360k               1   // 360kB floppy drive
#define FLOPPY_1200k              2   // 1,2MB floppy drive
#define FLOPPY_720k               3   // 720kB floppy drive
#define FLOPPY_1440k              4   // 1,44MB floppy drive
#define FLOPPY_2880k              5   // 2,88MB floppy drive
#define FLOPPY_20Mb               6   // 20.8MB floppy drive
#define FLOPPY_160k              10  // 160kB floppy drive
#define FLOPPY_180k              11  // 180kB floppy drive
#define FLOPPY_320k              12  // 320kB floppy drive

//*****************************************************************************
//
//*****************************************************************************

#endif                         // #ifndef _XBTDISK_CH

// * EOF *
