//////////////////////////////////////////////////////////////////////
//
//  XBTMISC.CH
//
//  Copyright:
//      Alaska Software, (c) 1996-2023. All rights reserved.         
//  
//  Contents:
//      #define-constants for data types and keyboard type
//   
//////////////////////////////////////////////////////////////////////


#ifndef _XBTMISC_CH
#define _XBTMISC_CH

//*****************************************************************************
// DataType() 
//*****************************************************************************

#define TYPE_UNDEF                0    // NIL
#define TYPE_STR                  1    // String
#define TYPE_NUM                  2    // Numeric
#define TYPE_LOG                  4    // Logic
#define TYPE_DATE                 8    // Date
#define TYPE_ALIAS               16    // Alias
#define TYPE_MEMO                 1    // MemoField
#define TYPE_WORD               128    // 16-Bit Word
#define TYPE_ARRAY              512    // Array
#define TYPE_OBJECT            1024    // Object 
#define TYPE_BLOCK             4096    // Codeblock

//*****************************************************************************
// KbdType()
//*****************************************************************************

#define KEYBOARD_PC               0    // PC-Keyboard
#define KEYBOARD_AT               1    // AT-Keyboard
#define KEYBOARD_MF2              2    // MF2-Keyboard with 101/102 Buttons

#endif                                 // #ifndef _XBTMISC_CH

// * EOF *
