//////////////////////////////////////////////////////////////////////
//
//  XBTNETB.CH
//
//  Copyright:
//       Alaska Software, (c) 1996-2023. All rights reserved.         
//  
//  Contents:
//       Definitions for XbTools-III NetBIOS functions
//       ( Point to Point Communication functions )
//   
//////////////////////////////////////////////////////////////////////


#ifndef _XBTNETB_CH

// Buffer types for PpcBufTyp()
#define PPC_NBD                            2
#define PPC_NBS                           18

// Return codes for NbError()            
#define NB_COMMAND_SUCCESSFUL              0
#define NB_ILLEGAL_BUFFER_LEN              1
#define NB_INVALID_COMMAND                 3
#define NB_COMMAND_TIME_OUT                5
#define NB_MESSAGE_INCOMPLETE              6
#define NB_DATA_NOT_RECEIVED               7
#define NB_ILLEGAL_LOCAL_SESSION           8
#define NB_NO_RES_AVAILABLE                9
#define NB_SESSION_CLOSED                 10
#define NB_COMMAND_CANCELLED              11
#define NB_DUPLICATE_NAME                 13
#define NB_NAME_TABLE_FULL                14
#define NB_CMND_CMPL_DEREGISTERED         15
#define NB_SESSION_TABLE_FULL             17
#define NB_SES_OPEN_REJECTED              18
#define NB_ILLEGAL_NAME_NUMBER            19
#define NB_REMOTE_NAME_NOT_FOUND          20
#define NB_LOCAL_NAME_NOT_FOUND           21
#define NB_NAME_IN_USE                    22
#define NB_NAME_DELETED                   23
#define NB_SESSION_ENDED_ABNORMALLY       24
#define NB_NAME_CONFLICT                  25
#define NB_INTERFACE_BUSY                 33
#define NB_MAX_CMNDS_EXCEEDED             34
#define NB_INVALID_ADAPTER                35
#define NB_CMND_ALREADY_COMPLETED         36
#define NB_CMND_INVALID_TO_CANCEL         38
#define NB_NAME_DEFINED_BY_OTHERS         48
#define NB_ENVIRONMENT_NOT_DEFINED        52
#define NB_NO_OS_RESOURCES                53
#define NB_MAX_APPL_EXCEEDED              54
#define NB_NO_SAP_AVAILABLE               55
#define NB_INADEQUATE_RESOURCES           56
#define NB_INVALID_NCB_ADDRESS            57
#define NB_RESET_INVALID                  58
#define NB_INVALID_DD_ID                  59
#define NB_SEGMENT_LOCK_UNSUCCESSFUL      60
#define NB_DD_OPEN_ERROR                  63
#define NB_OS_ERROR_DETECTED              64
#define NB_PERM_RING_STATUS               79

#define NB_UNEXPECTED_CCB_ERROR          246
#define NB_ADAPTER_OPEN_ERROR            248
#define NB_ADAPTER_HANDLER_ERROR         249
#define NB_ADAPTER_CHECK                 250
#define NB_CODE_NOT_OPERATIONAL          251
#define NB_OPEN_FAILURES                 252
#define NB_UNEXPECTED_CLOSE              253

#define NB_COMMAND_IN_PROCESS            255

#define _XBTNETB_CH
#endif

