//////////////////////////////////////////////////////////////////////
//
//  XBTPRINT.CH
//
//  Copyright:
//      Alaska Software, (c) 1996-2023. All rights reserved.         
//  
//  Contents:
//      Definitions for XbTools-III print functions
//   
//////////////////////////////////////////////////////////////////////


#ifndef _XBTPRINT_CH_

/*
 * Definitions for PrintStat(), PrintInit()
 */
#define PST_TIME_OUT            1      // Timeout error 
#define PST_TRANSFER            8      // I/O error 
#define PST_ONLINE             16      // Printer online 
#define PST_PAPER              32      // Printer out of paper 
#define PST_ACKNOWLEDGE        64      // Acknowledged 
#define PST_NOT_BUSY          128      // Printer not busy 

/*
 * Definitions for PrintError()
 */

#define P_ERR_ACCESS_DENIED     5      // access denied
#define P_ERR_UNKOWN_HANDLE     6      // unknown handle
#define P_ERR_USER_BREAK      127      // user terminated with Ctrl-Break

/*
 * Definitions for SpoolControl()
 */
#define SPL_DELETE_CURJOB       0      // Delete current print job    
#define SPL_PAUSE               1      // Pause printing    
#define SPL_CONTINUE            2      // Continue paused print job    
#define SPL_RESTART             3      // Restart print job    
#define SPL_HOLD                4      // Hold spooler    
#define SPL_RELEASE             5      // Release held spooler    

#define _XBTPRINT_CH_
#endif

