//////////////////////////////////////////////////////////////////////
//
//  XBTSYS.CH
//
//  Copyright:
//      Alaska Software, (c) 1996-2023. All rights reserved.         
//  
//  Contents:
//      OS system error codes and constants for pcType()
//   
//////////////////////////////////////////////////////////////////////


#ifndef _XBTSYS_CH   
#define _XBTSYS_CH   

//*****************************************************************************
// OS file error code
//*****************************************************************************
#define NO_DISK_ERR                     0
#define ER_FILE_NOT_FOUND         -2  
#define ER_PATH_NOT_FOUND         -3  
#define ER_ACCESS_DENIED          -5  
#define ER_REMOVE_PATH           -16
#define ER_DIFFERENT_DEVICE      -17

//*****************************************************************************
// return values of pcType()
//*****************************************************************************

#define PC_NORMAL                255   //  normal PC
#define PC_XT                    254   //  PC-XT (with hard disk)
#define PC_JUNIOR                253   //  PC-Junior
#define PC_MODEL30               240   //  model 30
#define PC_XT_2                  251   //  XT/2
#define PC_LAPTOP                249   //  laptop
#define PC_AT                    252   //  AT / XT-286 / Modell 50 / Modell 80
#define PC_MODEL80               248   //  model 80
#define PC_COMPAQP                45   //  Compaq Portable
#define PC_COMPAQPP              154   //  Compaq Portable plus

//*****************************************************************************
// return values of cpuType()
//*****************************************************************************

#define CPU_80386  7
#define CPU_80486  8
#define CPU_80586  9

#endif                                 // #ifndef _XBTSYS_CH

// * EOF *
