#include "xwbpackage.ch"

/* BuiltIn Commands:
 * XWB quit
 * SET NAMESPACE TO XWB
 * Quit
 * XWB LOAD dll,level
 * XWB Unload name
 * XWB List
 * XWB run filename.xwb
 */

 /* Filenames of Visual Xbase++ configuration scripts
  * System gets executed at XWB startup where and
  * should be located where XWB.EXE is located.
  * Project gets executed when loading the XPJ file
  * and is searched in the project directory.
  */
 #define XWBDOT_SYSTEM_SCRIPT   "system.xwb"
 #define XWBDOT_PROJECT_SCRIPT  "project.xwb"

 /* execution level of command dispatcher. A Command entered
  * inside the Command Window in XWB gets executed in the
  * order of the given execution level. For example
  * first the Input Handler of XWB ask the Builtin level
  * to execute, if the Builtin dispatcher returns XWBDOT_UNKNOWN
  * the Language dispatcher is used, if it again returns
  * XWBDOT_UNKNOWN the dispatcher with the next higher
  * execution level is tried and so on for all registered
  * dispatchers. If the last dispatcher returns UNKNOWN
  * XWB tells the user "Command/Syntax unknown". If a dispatcher
  * is able to handle the command it must return SUCCESS OR FAILURE
  * which in turn stops forwarding the Input to the Dispatcher
  * chain.
  */
  #define XWBDOT_USER                      10
  #define XWBDOT_LANGUAGE                   5
  #define XWBDOT_BUILTIN                    1

 /* Internal used action callback sub identifier
  */
  #define XWBACTION_CLASS  1
  #define XWBACTION_BEFORE 2
  #define XWBACTION_AFTER  3
  #define XWBACTION_ON     4

/*
 *EOF*/