/*
 * XWB Plugin architecture
 */

/* XWB Project Object Types
 *
 */
#define XWBOBJECT_SOURCE      0x10000000
#define XWBOBJECT_FORM        0x20000000
#define XWBOBJECT_DATABASE    0x40000000
#define XWBOBJECT_ARC         0x00000001
#define XWBOBJECT_CH          0x00000002
#define XWBOBJECT_XFM         0x00000004
#define XWBOBJECT_PRG         0x00000008

/* Plug-In Types, this should be returned
 * when the _register Callback is executed.
 */
#define XWBPLUGIN_DOT          1
#define XWBPLUGIN_WIZARD       2
#define XWBPLUGIN_COMPONENT    3
#define XWBPLUGIN_ACTION       4

/* return values of command dispatcher, basically
 * a command dispatcher returns UNKNOWN if he was
 * not able to handle the command, if he has handled
 * a command a dispatcher must return SUCCESS OR FAILURE
 * A more detailed description shall be provided in case
 * of failure with the GetResult Callback.
 */
#define XWBDISPATCH_UNDEF                      0 // undefined state of command execution
#define XWBDISPATCH_SUCCESS                    1 // successfull execution, display result in output window
#define XWBDISPATCH_FAILURE                    2 // severe failure of excution
#define XWBDISPATCH_UNKNOWN                    3 // expr. or command unknown let next handler in chain try to execute
#define XWBDISPATCH_IGNORE                     4 // ignore result, expression failed for internal reason inform user in your handler
#define XWBDISPATCH_STOP                       5 // stops further execution of events

/*
 * Xbase++ Workbench ODE Customizable Events
 */
#define XWBCEVENT_UNKNOWN                      0
#define XWBCEVENT_TRACE                        1  
#define XWBCEVENT_OnStartup                    2
#define XWBCEVENT_BeforeNew                    3
#define XWBCEVENT_AfterNew                     4
#define XWBCEVENT_BeforeNewApp                 5
#define XWBCEVENT_AfterNewApp                  6
#define XWBCEVENT_BeforeNewSource              7
#define XWBCEVENT_AfterNewSource               8
#define XWBCEVENT_BeforeNewForm                9
#define XWBCEVENT_AfterNewForm                 10
#define XWBCEVENT_BeforeOpenFile               11
#define XWBCEVENT_AfterOpenFile                12
#define XWBCEVENT_BeforeOpenProject            13
#define XWBCEVENT_AfterOpenProject             14
#define XWBCEVENT_BeforeReopenProject          15
#define XWBCEVENT_AfterReopenProject           16
#define XWBCEVENT_BeforeSave                   17
#define XWBCEVENT_AfterSave                    18
#define XWBCEVENT_BeforeSaveAs                 19
#define XWBCEVENT_AfterSaveAs                  20
#define XWBCEVENT_BeforeSaveAll                21
#define XWBCEVENT_AfterSaveAll                 22
#define XWBCEVENT_BeforeClose                  23
#define XWBCEVENT_AfterClose                   24
#define XWBCEVENT_BeforeCloseAll               25
#define XWBCEVENT_AfterCloseAll                26
#define XWBCEVENT_OnShutdown                   27
#define XWBCEVENT_BeforeOpenUnknown            28
#define XWBCEVENT_BeforeAddAsset               29
#define XWBCEVENT_AfterAddAsset                30
#define XWBCEVENT_BeforeRemoveAsset            31
#define XWBCEVENT_AfterRemoveAsset             32
#define XWBCEVENT_BeforeUpdateAsset            33
#define XWBCEVENT_AfterUpdateAsset             34
#define XWBCEVENT_BeforeRenameFile             35
#define XWBCEVENT_AfterRenameFile              36
#define XWBCEVENT_BeforeRenameTarget           37
#define XWBCEVENT_AfterRenameTarget            38
#define XWBCEVENT_BeforeRemoveFile             39
#define XWBCEVENT_AfterRemoveFile              40
#define XWBCEVENT_BeforeRemoveTarget           41
#define XWBCEVENT_AfterRemoveTarget            42
#define XWBCEVENT_BeforeCreateTargetFromExample 43
#define XWBCEVENT_AfterCreateTargetFromExample  44
#define XWBCEVENT_BeforeUseAsset               45
#define XWBCEVENT_AfterUseAsset                46
#define XWBCEVENT_COUNT                        46 // update me to reflect the highest #

/*
 *EOF*/