"""\
"""
import sys
import json
from datetime import datetime

def xbasearray(xString, todate=True):
    xbasearray.curPos = 0
    xbasearray.xString = xString.replace('\n','\n ')

    def split(n):
        s = xbasearray.xString[xbasearray.curPos:xbasearray.curPos+n]
        xbasearray.curPos += n
        t = xbasearray.curPos
        return s

    def restm(nextType):
        curList = []
        lenList = int(split(4))
        t = xbasearray.curPos

        for i in range(lenList):
            iType = split(1)
            if iType == 'A':    # array
                ll = restm(iType)
                curList.append(ll)
            elif iType == 'D':  # date
                x = split(8)
                if todate:
                    curList.append(datetime.date(intDef(x[:4],1), intDef(x[4:6],1), intDef(x[6:],1)) )
                else:
                    curList.append( '%s-%s-%s' % (x[:4],x[4:6],x[6:]) )
            elif iType == 'L':  # logic
                x = split(1)
                curList.append(x=='T')
            elif iType == 'N':  # numeric
                x = split(2)
                x = split(int(x))
                if x.find('.') == -1:
                    curList.append(int(x))
                else:
                    curList.append(float(x))
            elif iType == 'C' or iType == 'M':  # string
                x = split(5)
                x = split(int(x))
                curList.append(x)
            else:
                print iType, xbasearray.curPos
        return curList
    if not xString: return []
    nextType = split(1)
    return restm(nextType)

def xdict(xlist, tolist=True):
    """Passo una lista, e se l'array e' bidimensionale con chiave/valore lo trasformo
    in un dizionario. Questo serve perche' posso generare facilmente un json
    """

    def is2d(l):
        """L'oggetto passato deve essere una lista ed il primo elemento deve
        essere una lista di 2 elementi in cui il primo e' una stringa che incomincia con una lettera.
        Bisognerebbe controllare tutti gli elementi della lista ma la diamo per buona
        """
        if not l: return False
        if not type(l) is list: return False
        if not type(l[0]) is list: return False
        if len(l[0]) <> 2 : return False
        if not l[0][0]: return False
        if not type(l[0][0]) is str: return False
        if l[0][0][0].isdigit(): return False
        return True

    d = {}
    if is2d(xlist):
        for i in xlist:
            d[i[0]] = xdict(i[1])
    elif type(xlist) is list:
        for i in range(len(xlist)):
            xlist[i] = xdict(xlist[i])
        return xlist
    else:
        return xlist

    return d


if __name__ == '__main__':
    file_in = 'x2json_test.txt'
    if len(sys.argv) > 1:
        file_in = sys.argv[1]

    with open(file_in) as f:
        xbaseString = f.read()
        f.close()

    file_out = 'x2json.json'
    if len(sys.argv) > 2:
        file_out = sys.argv[2]

    l = xbasearray(xbaseString, False)
    d = xdict(l)
    s = json.dumps(d, indent=4, ensure_ascii=False)

    with open(file_out, 'w') as f:
       f.write(s)
       f.close()
